//	-------------------------------------------------------------------------
//
//	BSP.HPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Darren J. Dwyer
//
//	DESCRIPTION:	This file defines the main program (derived from Program)
//
//	-------------------------------------------------------------------------

#ifndef __bsp_hpp
#define __bsp_hpp

#include "program.hpp"
#include "palettes.hpp"

//	-------------------------------------------------------------------------
//
//	CLASS:		BSP
//	DESC:		The MAIN object which is the "program". See PROGRAM.?PP
//
//	-------------------------------------------------------------------------

class BSP: public Program
	{
	private:
		grPalette* orig_pal;

	public:
		BSP(char* init_string,int options);
		virtual ~BSP();

		void MainLoop();
	};

//	-------------------------------------------------------------------------
//
//	FUNC:		main()
//	DESC:		This is the function called initially.
//				At the moment it:
//					(1) creates our program
//					(2) executes Program::Execute()
//					(5) deletes our program & exits
//
//	-------------------------------------------------------------------------
void main(int argc,char** argv);

#endif