//
//	BSP data definitions
//

#include "graphics.hpp"

// the size of the display area	(d3?? felt good at the time... doing 3D bits)
#define d3_left		0
#define d3_top		20
#define d3_right	540
#define d3_bottom	380

#define d3_width	(d3_right-d3_left)
#define	d3_height	(d3_bottom-d3_top)

// event-handler numbers for global access between eventhandlers (sortof)
extern	int	evhno_Processor;
extern	int evhno_OptionsWindow;
extern	int evhno_InfoWindow;
extern	int	evhno_ViewWindow;
extern	int	evhno_3DWindow;

// command-events

#define	cmdIncVertPts			2000
#define cmdDecVertPts			2001

#define cmdIncHorizPts			2100
#define cmdDecHorizPts			2101

#define cmdIncPlainsHeight		2200
#define cmdDecPlainsHeight		2201
#define cmdIncRollingHeight		2202
#define cmdDecRollingHeight		2203
#define cmdIncHillsHeight		2204
#define cmdDecHillsHeight		2205
#define cmdIncMaximumHeight		2306
#define cmdDecMaximumHeight		2307

#define cmdIncNumRolling		2400
#define cmdDecNumRolling		2401
#define cmdIncNumHills			2402
#define cmdDecNumHills			2403
#define cmdIncNumMountains		2404
#define cmdDecNumMountains		2405

#define cmdIncRollingRangeSize	2500
#define cmdDecRollingRangeSize	2501
#define cmdIncHillRangeSize		2502
#define cmdDecHillRangeSize		2503
#define cmdIncMountainRangeSize	2504
#define cmdDecMountainRangeSize	2505

#define cmdShowView				3000
#define cmdShow3D				3001

#define cmdGenerate				4000

// global variables

#define MAX_RANGE_LENGTH		100

extern	int ctrl_pts_x;
extern	int	ctrl_pts_y;

extern	int minimum_height;
extern	int sea_max;
extern	int swamp_max;
extern	int grass_max;
extern	int plains_max;
extern	int hills_max;
extern	int mountains_max;
extern	int maximum_height;

// number of seperate starting locations for:
extern	int num_lakes;
extern	int num_swamp;
extern	int num_grass;
extern	int num_plains;
extern	int num_hills;
extern	int num_mountains;

// how long a mountain range will grow
extern	int range_length;

// how far they spread:
extern	int spread_lakes;
extern	int spread_swamp;
extern	int spread_grass;
extern	int spread_plains;
extern	int spread_hills;
extern	int spread_mountains;

// how much the height will change from control point to control point
// keep as odd numbers
extern	int variation_lakes;
extern	int variation_swamp;
extern	int variation_grass;
extern	int variation_plains;
extern	int variation_hills;
extern	int variation_mountains;

extern	grVirtualBuffer* map;   // storage of 2D (overhead view) map
extern	grVirtualBuffer* map3D;	// storage of 3D map

extern	int	display_mode;		// current display mode
