//	-------------------------------------------------------------------------
//
//	BACKGRND.HPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Darren J. Dwyer
//
//	DESCRIPTION:	this file contains the definition for the standard
//					'background task'
//
//	-------------------------------------------------------------------------

#ifndef __backgrnd_hpp
#define __backgrnd_hpp

#include "handler.hpp"

//	-------------------------------------------------------------------------
//
//	CLASS:	BackgroundTask
//
//	DESC:   This is an object that can send & receive events from the event
//			manager but is not meant to display anything on the screen.
//			It is meant to be some kind of event-processor....
//			ie. Comm-Port, Interface, Network, etc.
//
//	-------------------------------------------------------------------------

class BackgroundTask : public EventHandler
	{
	protected:
	public:
		BackgroundTask(	int* evhno,			// the event handler no.
						int options );	    // the background task options

		virtual ~BackgroundTask();
	};

#endif

