//	-----------------------------------------------------------------------
//
//		FRACTAL.HPP
//
//		Andrew Evans - September 95.
//
//		This is source for a variety of fractal methods and
//		implementation.
//
//	-----------------------------------------------------------------------
#ifndef       __fractal_hpp
#define       __fractal_hpp

#include		"graphics.hpp"

//	-----------------------------------------------------------------------

void fractal_Init(grVirtualBuffer* working_map, grRect position, int seed = 0);
void fractal_Exit();

//	LINE ------------------------------------

// will bend a line x1,y1 x2,y2 in a fractal manner
// recursively will move randomly the midpoint of a line
// until the line we are working on is below a certain length
void fractal_Line(int x1,int y1, int x2,int y2, uchar land);
void fractal_IterateLine(int x1,int y1, int x2,int y2, float standard_deviation);

//	AREA ------------------------------------

void fractal_Area(int x,int y, int radius, uchar land);
void fractal_IterateArea(int x,int y, int radius);

#endif
