#include "grmisc.hpp"
#include "rects.hpp"
#include "lines.hpp"

// draw a window from x1,y1 to x2,y2 using border style 'bs' and a background
// color. NOTE: If background color==0 (BLACK) we assume no floodfill!!!

void grDrawWindowVirtual(grVirtualBuffer* vb,int x1,int y1,int x2,int y2,int bgcolor,int bs)
	{
	if (vb==NULL) return;

	CLIP2(x1,y1,0,0,vb->hdr.width-1,vb->hdr.height-1);
	CLIP2(x2,y2,0,0,vb->hdr.width-1,vb->hdr.height-1);

	// assume that black is the transparent color
	if (bgcolor!=-1) grDrawFilledRectVirtual(vb,x1,y1,x2,y2,bgcolor);

	switch (bs)
		{
		case	bs_NONE:		break;
		case	bs_OUTLINE:		grDrawRectVirtual(vb,x1,y1,x2,y2,grWINDOW_HIGHLIGHT);
								break;
		case	bs_FRAMED:		//grDrawWindow(x1,y1,x2,y2,bg,bs_RAISED);
								//x1+=bSize_RAISED;x2-=bSize_RAISED;
								//y1+=bSize_RAISED;y2-=bSize_RAISED;
								//grDrawWindow(x1,y1,x2,y2,bg,bs_LOWERED);
								break;
		case	bs_EDGED:       //grDrawWindow(x1,y1,x2,y2,bg,bs_LOWERED);
								//x1+=bSize_LOWERED;x2-=bSize_LOWERED;
								//y1+=bSize_LOWERED;y2-=bSize_LOWERED;
								//grDrawWindow(x1,y1,x2,y2,bg,bs_RAISED);
								break;
		case	bs_RAISED:		grDrawVLineVirtual(vb,x1,y1,y2,grWINDOW_HIGHLIGHT);		// left
								grDrawVLineVirtual(vb,x1+1,y1+1,y2-1,grWINDOW_HIGHLIGHT);
								grDrawVLineVirtual(vb,x2,y1,y2,grWINDOW_LOWLIGHT);		// right
								grDrawVLineVirtual(vb,x2-1,y1+1,y2-1,grWINDOW_LOWLIGHT);

								grDrawHLineVirtual(vb,y1,x1,x2,grWINDOW_HIGHLIGHT);		// top
								grDrawHLineVirtual(vb,y1+1,x1+1,x2-1,grWINDOW_HIGHLIGHT);
								grDrawHLineVirtual(vb,y2,x1,x2,grWINDOW_LOWLIGHT);		// bottom
								grDrawHLineVirtual(vb,y2-1,x1+1,x2-1,grWINDOW_LOWLIGHT);
								break;
		case	bs_LOWERED:     grDrawVLineVirtual(vb,x1,y1,y2,grWINDOW_LOWLIGHT);		// left
								grDrawVLineVirtual(vb,x1+1,y1+1,y2-1,grWINDOW_LOWLIGHT);
								grDrawVLineVirtual(vb,x2,y1,y2,grWINDOW_HIGHLIGHT);		// right
								grDrawVLineVirtual(vb,x2-1,y1+1,y2-1,grWINDOW_HIGHLIGHT);

								grDrawHLineVirtual(vb,y1,x1,x2,grWINDOW_LOWLIGHT);		// top
								grDrawHLineVirtual(vb,y1+1,x1+1,x2-1,grWINDOW_LOWLIGHT);
								grDrawHLineVirtual(vb,y2,x1,x2,grWINDOW_HIGHLIGHT);		// bottom
								grDrawHLineVirtual(vb,y2-1,x1+1,x2-1,grWINDOW_HIGHLIGHT);
								break;
		case	bs_DBLRAISED:   grDrawVLineVirtual(vb,x1,y1,y2,grWINDOW_HIGHLIGHT);		// left
								grDrawVLineVirtual(vb,x1+1,y1+1,y2-1,grWINDOW_HIGHLIGHT);
								grDrawVLineVirtual(vb,x1+2,y1+2,y2-2,grWINDOW_HIGHLIGHT);
								grDrawVLineVirtual(vb,x1+3,y1+3,y2-3,grWINDOW_HIGHLIGHT);

								grDrawVLineVirtual(vb,x2,y1,y2,grWINDOW_LOWLIGHT);		// right
								grDrawVLineVirtual(vb,x2-1,y1+1,y2-1,grWINDOW_LOWLIGHT);
								grDrawVLineVirtual(vb,x2-2,y1+2,y2-2,grWINDOW_LOWLIGHT);
								grDrawVLineVirtual(vb,x2-3,y1+3,y2-3,grWINDOW_LOWLIGHT);

								grDrawHLineVirtual(vb,y1,x1,x2,grWINDOW_HIGHLIGHT);		// top
								grDrawHLineVirtual(vb,y1+1,x1+1,x2-1,grWINDOW_HIGHLIGHT);
								grDrawHLineVirtual(vb,y1+2,x1+2,x2-2,grWINDOW_HIGHLIGHT);
								grDrawHLineVirtual(vb,y1+3,x1+3,x2-3,grWINDOW_HIGHLIGHT);

								grDrawHLineVirtual(vb,y2,x1,x2,grWINDOW_LOWLIGHT);		// bottom
								grDrawHLineVirtual(vb,y2-1,x1+1,x2-1,grWINDOW_LOWLIGHT);
								grDrawHLineVirtual(vb,y2-2,x1+2,x2-2,grWINDOW_LOWLIGHT);
								grDrawHLineVirtual(vb,y2-3,x1+3,x2-3,grWINDOW_LOWLIGHT);
								break;
		case	bs_DBLLOWERED:  grDrawVLineVirtual(vb,x1,y1,y2,grWINDOW_LOWLIGHT);  	// left
								grDrawVLineVirtual(vb,x1+1,y1+1,y2-1,grWINDOW_LOWLIGHT);
								grDrawVLineVirtual(vb,x1+2,y1+2,y2-2,grWINDOW_LOWLIGHT);
								grDrawVLineVirtual(vb,x1+3,y1+3,y2-3,grWINDOW_LOWLIGHT);

								grDrawVLineVirtual(vb,x2,y1,y2,grWINDOW_HIGHLIGHT);		// right
								grDrawVLineVirtual(vb,x2-1,y1+1,y2-1,grWINDOW_HIGHLIGHT);
								grDrawVLineVirtual(vb,x2-2,y1+2,y2-2,grWINDOW_HIGHLIGHT);
								grDrawVLineVirtual(vb,x2-3,y1+3,y2-3,grWINDOW_HIGHLIGHT);

								grDrawHLineVirtual(vb,y1,x1,x2,grWINDOW_LOWLIGHT);      // top
								grDrawHLineVirtual(vb,y1+1,x1+1,x2-1,grWINDOW_LOWLIGHT);
								grDrawHLineVirtual(vb,y1+2,x1+2,x2-2,grWINDOW_LOWLIGHT);
								grDrawHLineVirtual(vb,y1+3,x1+3,x2-3,grWINDOW_LOWLIGHT);

								grDrawHLineVirtual(vb,y2,x1,x2,grWINDOW_HIGHLIGHT);		// bottom
								grDrawHLineVirtual(vb,y2-1,x1+1,x2-1,grWINDOW_HIGHLIGHT);
								grDrawHLineVirtual(vb,y2-2,x1+2,x2-2,grWINDOW_HIGHLIGHT);
								grDrawHLineVirtual(vb,y2-3,x1+3,x2-3,grWINDOW_HIGHLIGHT);
								break;
		default:				break;
		}
	}

// --------------------------------------------------------------------------
//
//	FUNC:		grFloodFill()
//	DESC:		very simple floodfill algorithm (that works!!)
//
// --------------------------------------------------------------------------
void grFloodFill(grVirtualBuffer* vb, int x,int y, int color)
	{
	if (vb==NULL) return;

	int		yy = y;
	uchar	bg = vb->data[Index(vb,x,y)];

	int		width = vb->hdr.width;
	int		height = vb->hdr.height;

	// fill by row upwards
	while ((vb->data[Index(vb,x,yy)] == bg) && (yy>=0))
		{
		int x1 = x,x2 = x;

		while ((vb->data[Index(vb,x1,yy)] == bg) && (x1>=0)) x1--;
		while ((vb->data[Index(vb,x2,yy)] == bg) && (x2<width)) x2++;

		x1++; x2--;
		SYS_Memset(&vb->data[Index(vb,x1,yy)],color,x2-x1+1);
		yy--;
		}

	yy = y+1;

	// fill by row downwards
	while ((vb->data[Index(vb,x,yy)] == bg) && (yy<height))
		{
		int x1 = x,x2 = x;

		while ((vb->data[Index(vb,x1,yy)] == bg) && (x1>=0)) x1--;
		while ((vb->data[Index(vb,x2,yy)] == bg) && (x2<width)) x2++;

		x1++; x2--;
		SYS_Memset(&vb->data[Index(vb,x1,yy)],color,x2-x1+1);
		yy++;
		}
	}



