#ifndef __grmisc_hpp
#define __grmisc_hpp

#include "vbuffer.hpp"
#include "images.hpp"

// --------------------------------------------------------------------------
//
//	MISCELLANEOUS GRAPHICS DEFINITIONS
//
// --------------------------------------------------------------------------

// standard palette used by graphics functions

#define	grBLACK			0
#define grBLUE			1
#define	grGREEN			2
#define grCYAN			3
#define	grRED			4
#define	grMAGENTA		5
#define	grBROWN			6
#define grLIGHTGRAY		7
#define grDARKGRAY		8
#define grLIGHTBLUE		9
#define grLIGHTGREEN	10
#define	grLIGHTCYAN		11
#define	grLIGHTRED		12
#define	grLIGHTMAGENTA	13
#define	grYELLOW		14
#define	grWHITE			15

// The following are the color-indexes reserved for GUI-specific display

#define	grBACKGROUND				0
#define	grWINDOW_FG					1
#define grWINDOW_BG					2
#define	grWINDOW_HIGHLIGHT			3
#define	grWINDOW_LOWLIGHT			4
#define	grACCESSORY_FG				5
#define grACCESSORY_BG              6
#define	grACCESSORY_HIGHLIGHT		7
#define grACCESSORY_LOWLIGHT        8
#define	grINPUTCURSOR				9
#define	grSHADECOLOR				10	//ACE
#define	grRESERVED11	11
#define	grRESERVED12	12
#define	grRESERVED13	13
#define	grRESERVED14	14
#define	grRESERVED15	15
#define	grRESERVED16	16
#define	grRESERVED17	17
#define	grRESERVED18	18
#define	grRESERVED19	19
#define	grRESERVED20	20
#define	grRESERVED21	21
#define	grRESERVED22	22
#define	grRESERVED23	23
#define	grRESERVED24	24
#define	grRESERVED25	25
#define	grRESERVED26	26
#define	grRESERVED27	27
#define	grRESERVED28	28
#define	grRESERVED29	29
#define	grRESERVED30	30
#define	grRESERVED31	31

// --------------------------------------------------------------------------
//
//	MISCELLANEOUS GRAPHICS FUNCTIONS
//
// --------------------------------------------------------------------------


// ---	draw a window from x1,y1 to x2,y2 using line border style 'bs'
//		and a background color.
//		NOTE: background color == -1 means don't fill

// 		* some different border styles used in grDrawWindow(), etc.

#define bs_NONE			0
#define bs_OUTLINE		1
#define bs_FRAMED		2
#define bs_EDGED		3
#define bs_RAISED		4
#define bs_LOWERED		5
#define bs_DBLRAISED	6
#define bs_DBLLOWERED   7
#define bs_QUADRAISED	8
#define bs_QUADLOWERED	9

// 		* sizes of borders 	eg. bordersize = grSizeOfBorder[DBLRAISED];

const  int grSizeOfBorder[] = { 0, 1, 6, 6, 1, 1, 2, 2, 8, 8 };

#define	grDrawWindow(X1,Y1,X2,Y2,BG,BSTYLE)	\
			grDrawWindowVirtual(grSCREEN,(X1),(Y1),(X2),(Y2),(BG),(BSTYLE))


// ---	draw a window from x1,y1 to x2,y2 using line border 'bs'
//		and a background color.
// 		NOTE: background color == -1 means don't fill

void grDrawWindowVirtual(grVirtualBuffer* vb,
							int x1,int y1,int x2,int y2,
							int bgcolor,int bs);


// ---	quick flood-fill routine

void 	grFloodFill(grVirtualBuffer* vb, int x,int y, int color);

#endif
