//	-------------------------------------------------------------------------
//
//	GUI.CPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Darren J. Dwyer
//
//	DESCRIPTION:	This file implements pre-defined picture buttons, etc.
//
//	-------------------------------------------------------------------------

#include "gui.hpp"
#include "program.hpp"
#include "resource.hpp"

//	--------------

grImage**		GUI_BITMAPS = NULL;
ResourceFile*	GUI_BITMAPS_FILE = NULL;

//	--------------

void InstallGUI(char* path,char* gui_res)
	{
	// open the folder icons file
	GUI_BITMAPS_FILE = new ResourceFile(path,"resource\\gui.res");
	if (!GUI_BITMAPS_FILE)
		{
		DBG(470,"ERROR (OPTIONS): Could not find RESOURCE\\GUI.RES");
		return;
		}
	// read in all required icons
	GUI_BITMAPS = (grImage**) GUI_BITMAPS_FILE->ReadAllRecords();
	if (!GUI_BITMAPS)
		{
		DBG(470,"ERROR (OPTIONS): Could not read RESOURCE\\GUI.RES");
		delete GUI_BITMAPS_FILE; GUI_BITMAPS_FILE = NULL;
		return;
		}
	}

//	--------------

void ExitGUI()
	{
	if (GUI_BITMAPS) GUI_BITMAPS_FILE->FreeAllRecords((char**) GUI_BITMAPS);
	delete GUI_BITMAPS_FILE;
	}

