//
//  KEYDEFNS.HPP
//
//	#defns to use most (if not all) of the keyboard simply
//

#ifndef __keydefns_h
#define __keydefns_h

//
// 	defines for keys being pressed down
//

// function keys row
#define	ESC_DN				1
#define	F1_DN				59
#define F2_DN				60
#define F3_DN				61
#define F4_DN				62
#define F5_DN				63
#define F6_DN				64
#define F7_DN				65
#define F8_DN				66
#define F9_DN				67
#define F10_DN				68
#define F11_DN				87
#define F12_DN				88
#define PRINT_SCREEN_DN		55
#define SCROLL_LOCK_DN		70

// numbers row
#define	TILDA_DN			41
#define	ONE_DN				2
#define	TWO_DN				3
#define THREE_DN			4
#define FOUR_DN				5
#define FIVE_DN				6
#define	SIX_DN				7
#define SEVEN_DN			8
#define EIGHT_DN			9
#define NINE_DN				10
#define ZERO_DN				11
#define MINUS_DN			12
#define EQUALS_DN			13
#define BS_DN				14

// qwerty row
#define TAB_DN				15
#define Q_DN				16
#define W_DN				17
#define E_DN				18
#define R_DN				19
#define T_DN				20
#define Y_DN				21
#define U_DN				22
#define I_DN				23
#define O_DN				24
#define P_DN				25
#define LEFT_BRACKET_DN		26
#define RIGHT_BRACKET_DN	27
#define ENTER_DN			28

// asdf row
#define CAPS_LOCK_DN		58
#define A_DN				30
#define S_DN				31
#define D_DN				32
#define F_DN				33
#define G_DN				34
#define H_DN				35
#define J_DN				36
#define K_DN				37
#define L_DN				38
#define COLON_DN			39
#define QUOTE_DN			40

// zxcv row
#define	LEFT_SHIFT_DN		100
#define Z_DN				44
#define X_DN				45
#define C_DN				46
#define V_DN				47
#define B_DN				48
#define N_DN				49
#define M_DN				50
#define COMMA_DN			51
#define PERIOD_DN			52
#define DIVIDE_DN			53
#define RIGHT_SHIFT_DN		101

// space bar row
#define LEFT_CTRL_DN		102
#define LEFT_ALT_DN			104
#define SPACE_DN        	57
#define RIGHT_ALT_DN		105
#define RIGHT_CTRL_DN		103
#define BACKSLASH_DN		43

// editting keys
#define INS_DN				82
#define DEL_DN				83
#define HOME_DN				71
#define END_DN				79
#define PGUP_DN				73
#define PGDN_DN				81

// arrow keys
#define UP_ARROW_DN			72
#define DN_ARROW_DN			80
#define LT_ARROW_DN			75
#define RT_ARROW_DN			77

// keypad keys - note that they simply translate to the arrow/editting keys
//	(in reality they translate the other way, but its the same...)
#define NUM_LOCK_DN			69
#define KP_DIVIDE_DN		QUESTION_MARK_DN
#define KP_MULTIPLY_DN		55		// note: same as PRINT_SCREEN (???)
#define KP_MINUS_DN			74
#define KP_SEVEN_DN			HOME_DN
#define KP_EIGHT_DN			UP_ARROW_DN
#define KP_NINE_DN			PGUP_DN
#define KP_PLUS_DN			78
#define KP_FOUR_DN			LT_ARROW_DN
#define KP_FIVE_DN			76
#define KP_SIX_DN			RT_ARROW_DN
#define KP_ONE_DN			END_DN
#define KP_TWO_DN			DN_ARROW_DN
#define	KP_THREE_DN			PGDN_DN
#define KP_ENTER_DN			ENTER_DN
#define KP_ZERO_DN			INS_DN
#define KP_POINT_DN			DEL_DN

//
// 	defines for keys being released
//

// function keys row
#define	ESC_UP				1001
#define	F1_UP				1059
#define F2_UP				1060
#define F3_UP				1061
#define F4_UP				1062
#define F5_UP				1063
#define F6_UP				1064
#define F7_UP				1065
#define F8_UP				1066
#define F9_UP				1067
#define F10_UP				1068
#define F11_UP				1087
#define F12_UP				1088
#define PRINT_SCREEN_UP		1055
#define SCROLL_LOCK_UP		1070

// numbers row
#define	TILDA_UP			1041
#define	ONE_UP				1002
#define	TWO_UP				1003
#define THREE_UP			1004
#define FOUR_UP				1005
#define FIVE_UP				1006
#define	SIX_UP				1007
#define SEVEN_UP			1008
#define EIGHT_UP			1009
#define NINE_UP				1010
#define ZERO_UP				1011
#define MINUS_UP			1012
#define EQUALS_UP			1013
#define BS_UP				1014

// qwerty row
#define TAB_UP				1015
#define Q_UP				1016
#define W_UP				1017
#define E_UP				1018
#define R_UP				1019
#define T_UP				1020
#define Y_UP				1021
#define U_UP				1022
#define I_UP				1023
#define O_UP				1024
#define P_UP				1025
#define LEFT_BRACKET_UP		1026
#define RIGHT_BRACKET_UP	1027
#define ENTER_UP			1028

// asdf row
#define CAPS_LOCK_UP		1058
#define A_UP				1030
#define S_UP				1031
#define D_UP				1032
#define F_UP				1033
#define G_UP				1034
#define H_UP				1035
#define J_UP				1036
#define K_UP				1037
#define L_UP				1038
#define COLON_UP			1039
#define QUOTE_UP			1040

// zxcv row
#define	LEFT_SHIFT_UP		1100
#define Z_UP				1044
#define X_UP				1045
#define C_UP				1046
#define V_UP				1047
#define B_UP				1048
#define N_UP				1049
#define M_UP				1050
#define COMMA_UP			1051
#define PERIOD_UP			1052
#define DIVIDE_UP			1053
#define RIGHT_SHIFT_UP		1101

// space bar row
#define LEFT_CTRL_UP		1102
#define LEFT_ALT_UP			1104
#define SPACE_UP        	1057
#define RIGHT_ALT_UP		1105
#define RIGHT_CTRL_UP		1103
#define BACKSLASH_UP		1043

// editting keys
#define INS_UP				1082
#define DEL_UP				1083
#define HOME_UP				1071
#define END_UP				1079
#define PGUP_UP				1073
#define PGDN_UP				1081

// arrow keys
#define UP_ARROW_UP			1072
#define DN_ARROW_UP			1080
#define LT_ARROW_UP			1075
#define RT_ARROW_UP			1077

// keypad keys
#define NUM_LOCK_UP			1069
#define KP_DIVIDE_UP		QUESTION_MARK_UP
#define KP_MULTIPLY_UP		1055    // note: same as PRINT_SCREEN (???)
#define KP_MINUS_UP			1074
#define KP_SEVEN_UP			HOME_UP
#define KP_EIGHT_UP			UP_ARROW_UP
#define KP_NINE_UP			PGUP_UP
#define KP_PLUS_UP			1078
#define KP_FOUR_UP			LT_ARROW_UP
#define KP_FIVE_UP			1076
#define KP_SIX_UP			RT_ARROW_UP
#define KP_ONE_UP			END_UP
#define KP_TWO_UP			DN_ARROW_UP
#define	KP_THREE_UP			PGDN_UP
#define KP_ENTER_UP			ENTER_UP
#define KP_ZERO_UP			INS_UP
#define KP_POINT_UP			DEL_UP

#endif