#ifndef __lines_hpp
#define __lines_hpp

#include "vbuffer.hpp"

// --------------------------------------------------------------------------
//
//	LINE MACROS (BACKWARDS COMPATIBILITY & EASE OF READING)
//
// --------------------------------------------------------------------------

#define	grDrawLine(X1,Y1,X2,Y2,COLOR)	\
			grDrawLineVirtual(grSCREEN,(X1),(Y1),(X2),(Y2),(COLOR))

#define	grDrawVLine(X,Y1,Y2,COLOR)	\
			grDrawVLineVirtual(grSCREEN,(X),(Y1),(Y2),(COLOR))

#define	grDrawHLine(Y,X1,X2,COLOR)	\
			grDrawHLineVirtual(grSCREEN,(Y),(X1),(X2),(COLOR))

// --------------------------------------------------------------------------
//
//	VB IMPLEMENTATION FUNCTIONS
//
// --------------------------------------------------------------------------


// ---	draw a line in a virtual buffer from x1,y1 to x2,y2
//		in specified color
//		Note: This function is based upon Bresenham's algorithm IBM (1965)

void 	grDrawLineVirtual(grVB* vb,
						int x1, int y1, int x2, int y2, int color );


// ---	draw a vertical line in a virtual buffer from x,y1 to x,y2
//		in specified color

void 	grDrawVLineVirtual(grVB* vb,
							int x,int y1,int y2, int color );


// ---	draw a horizontal line in a virtual buffer from x1,y to x2,y
//		in specified color

void 	grDrawHLineVirtual(grVB* vb,
							int y,int x1,int x2, int color );

#endif
