//	-------------------------------------------------------------------------
//
//	PALFILE.HPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Andrew C. Evans
//
//	DESCRIPTION:	This file contains definitions for the PALFILE class
//
//	-------------------------------------------------------------------------

#ifndef __palfile_hpp
#define __palfile_hpp

#include "file.hpp"
#include "graphics.hpp"
#include "palettes.hpp"

#define			PALETTE_SIZE			768

class PALFile : public File
	{
	public:
				PALFile(char* filename);
				PALFile(String* filename);
				PALFile(char* path,char* filename);
				PALFile(String* path,String* filename);

		virtual grPalette*	LoadPalette();
		virtual int			SavePalette(grPalette* palette);

	protected:
		void 	PALFile::Convert256PaletteTo64Palette(grPalette* palette);
	};

#endif