//	-------------------------------------------------------------------------
//
//	PCX.HPP
//
//	-------------------------------------------------------------------------
#ifndef		__pcx_hpp
#define		__pcx_hpp

//	-------------------------------------------------------------------------
//
//	FUNC:		PCX_Decompress
//	DESC:		converts a run of PCX-compressed bytes to a run of
//				decompressed (raw) bytes.
//
//	PARAMS:		dest		- the address of the decompressed run
//				srce		- the address of the compressed run
//				decompressed_size 	- the number of bytes that were compressed
//				decompressed_width	- the number of bytes to decompress to (max)
//
//	RETURNS:	long		- the size of the _compressed_ data
//
//	-------------------------------------------------------------------------
long 	PCX_Decompress(char* dest, char* srce, long decompressed_size, long decompressed_width = 0);



//	-------------------------------------------------------------------------
//
//	FUNC:		PCX_Compress
//	DESC:		converts a row of decompressed (raw) bytes to a run of
//				PCX-compressed bytes.
//
//	PARAMS:		dest		- the address of the compressed run
//				srce		- the address of the decompressed run
//				decompressed_size 	- the number of bytes to be compressed
//				decompressed_width	- the number of bytes to compress to (max)
//
//	RETURNS:	long		- the size of the _compressed_ data
//
//	-------------------------------------------------------------------------
long	PCX_Compress(char* dest, char* srce, long decompressed_size, long decompressed_width = 0);


#endif
