#ifndef __points_hpp
#define __points_hpp

#include "vbuffer.hpp"

// --------------------------------------------------------------------------
//
//	POINT DEFINITIONS
//
// --------------------------------------------------------------------------

// the format of the generic "point"

struct grPoint
	{
	int 	x;
	int 	y;
	};

// --------------------------------------------------------------------------
//
//	POINT MACROS (BACKWARDS COMPATIBILITY & EASE OF READING)
//
// --------------------------------------------------------------------------

#define		grPutPixel(X,Y,COLOR)	\
				grPutPixelVirtual(grSCREEN,(X),(Y),(COLOR))

#define		grGetPixel(X,Y)			\
				grGetPixelVirtual(grSCREEN,(X),(Y))

// --------------------------------------------------------------------------
//
//	POINT IMPLEMENTATION FUNCTIONS
//
// --------------------------------------------------------------------------


// --- 	swaps two points

void 	grSwap(grPoint* v1, grPoint* v2);


// ---	draw a pixel of specified color into a virtual buffer
//		at specified x,y coords

void 	grPutPixelVirtual(grVB* vb,int x,int y,int color);


// ---	get a pixel from a virtual buffer at specified x,y coords

int 	grGetPixelVirtual(grVB* vb,int x,int y);

#endif