#include "rects.hpp"
#include "lines.hpp"
//DJD --- TEMPORARILY TILL HARDWARE CURSOR INTERFACE
#include "mouse.hpp"
//DJD --- END

//#include "conio.h"
//#include "stdio.h"

// -------------

void grDrawRectVirtual(grVB* vb,int x1, int y1, int x2, int y2, int color)
	{
	if (!vb) return;

	// make sure coords are clipped!!!
	CLIP2(x1,y1,0,0,vb->hdr.width-1,vb->hdr.height-1);
	CLIP2(x2,y2,0,0,vb->hdr.width-1,vb->hdr.height-1);

	grDrawVLineVirtual(vb,x1,y1,y2,color);
	grDrawVLineVirtual(vb,x2,y1,y2,color);
	grDrawHLineVirtual(vb,y1,x1,x2,color);
	grDrawHLineVirtual(vb,y2,x1,x2,color);
	}

// -------------

void grDrawFilledRectVirtual(grVB* vb,int x1,int y1,int x2,int y2, int color)
	{
	if (!vb) return;

	int vb_maxx = vb->hdr.width-1;
	int vb_maxy = vb->hdr.height-1;
	CLIP2(x1,y1,0,0,vb_maxx,vb_maxy);
	CLIP2(x1,y1,0,0,vb_maxx,vb_maxy);

	int x,y;

	BYTE	bfill = (BYTE) color;
	WORD 	wfill = bfill + (bfill<<8);
	DWORD   dfill = wfill + (wfill<<16);

	DWORD* 	dest;

	long 	vb_addr   = (long) &vb->data[0];
	int 	vb_width  = vb->hdr.width;
	int 	copy_width 	= x2-x1+1;			// total number of bytes to copy

	int dwords_to_copy  = copy_width >> 2;			// dwords to copy
	int words_to_copy   = ((copy_width&2)!=0);		// if word-aligned, copy 1 word
	int bytes_to_copy   = ((copy_width&1)!=0); 		// if byte-aligned, copy 1 byte

	// blit the rect
	for (y=y1;y<=y2;y++)
		{
//printf("DrawFilledRect(%p,%d,%d,%d,%d,%d) : row == %d\n",
//			vb,x1,y1,x2,y2,color,y);

//DJD --- TEMPORARILY TILL HARDWARE CURSOR INTERFACE
//mouse_UpdateCursor();
//DJD --- END
		dest = (DWORD*) (vb_addr + (y * vb_width) + x1);

		// splat all DWORDS across
		for (x=0;x<dwords_to_copy;x++)
			{
			*dest = dfill;
			dest++;
			}

		// if we need to copy a WORD
		if (words_to_copy)
			{
			WORD* wdest = (WORD*) dest;
			*wdest = wfill;
			wdest++;

			// we may need to copy a BYTE as well
			if (bytes_to_copy)
				{
				BYTE* bdest = (BYTE*) wdest;
				*bdest = bfill;
				}
			}
		else
			// we don't need to copy a word
			// but we may still need to copy a BYTE
			{
			if (bytes_to_copy)
				{
				BYTE* bdest1 = (BYTE*) dest;
				*bdest1 = bfill;
				}
			}
		}
	}

// -------------

void grDrawShadedRectVirtual(grVB* vb,int x1,int y1,int x2,int y2,
						int color,int spacing)
	{
	if (!vb) return;

	// make sure coords are clipped!!!
	CLIP2(x1,y1,0,0,vb->hdr.width-1,vb->hdr.height-1);
	CLIP2(x2,y2,0,0,vb->hdr.width-1,vb->hdr.height-1);

	int  	vb_width   	= vb->hdr.width;
	long 	dest_addr 	= (long) &vb->data[y1 * vb_width + x1];
	BYTE* 	dest;
	BYTE	colr = (BYTE) color;

	int copy_width  = x2-x1+1;
	int x,y;
	int offset;

	// blit the image

	for (y=y1;y<=y2;y++)
		{
//DJD --- TEMPORARILY TILL HARDWARE CURSOR INTERFACE
//mouse_UpdateCursor();
//DJD --- END

		offset = y % spacing;

		// splat all BYTES across
		long tmp_addr = dest_addr + (long) offset;

		for (x=offset;x<copy_width;x+=spacing)
			{
			dest = (BYTE*) tmp_addr;
			*dest = colr;
			tmp_addr += (long) spacing;
			}

		dest_addr += vb_width;
		}
	}

// -------------

bool	grPtInRect(grPoint p,grRect r)
	{
	if ((p.x<r.left) || (p.x>r.right)) return false;
	if ((p.y<r.top) || (p.y>r.bottom)) return false;

	return true;
	}

bool	grPtInRect(int x,int y,grRect r)
	{
	if ((x<r.left) || (x>r.right)) return false;
	if ((y<r.top) || (y>r.bottom)) return false;

	return true;
	}

bool		grPtInRect(grPoint p,grPoint r1,grPoint r2)
	{
	if ((p.x<r1.x) || (p.x>r2.x)) return false;
	if ((p.y<r1.y) || (p.y>r2.y)) return false;

	return true;
	}

bool		grPtInRect(int x,int y,grPoint r1,grPoint r2)
	{
	if ((x<r1.x) || (x>r2.x)) return false;
	if ((y<r1.y) || (y>r2.y)) return false;

	return true;
	}

bool		grPtInRect(grPoint p,int x1,int y1,int x2,int y2)
	{
	if ((p.x<x1) || (p.x>x2)) return false;
	if ((p.y<y1) || (p.y>y2)) return false;

	return true;
	}

bool		grPtInRect(int x,int y,int x1,int y1,int x2,int y2)
	{
	if ((x<x1) || (x>x2)) return false;
	if ((y<y1) || (y>y2)) return false;

	return true;
	}
