//	-------------------------------------------------------------------------
//
//	MAINLOOP.CPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Darren J. Dwyer
//
//	DESCRIPTION:	This is the code for the mouse-test event handler
//
//	-------------------------------------------------------------------------

#include "mainloop.hpp"
#include "eventmgr.hpp"
#include "buttons.hpp"
#include "program.hpp"

#include "dos.h"	// for delay()


MouseTester::MouseTester()
	: OnScreenHandler(0,0,grMaxx,grMaxy,
					  &evhno_MouseTester,0,1)
	{
	}

void MouseTester::Draw()
	{
	grDrawFilledRect(0,0,grMaxx,grMaxy,grBLACK);
	grDrawString(0,0,"In MouseTester()");
	}

void MouseTester::HandleEvent(Event &e)
	{
	// do all the _boring_ event processing
	OnScreenHandler::HandleEvent(e);

	switch (e.what)
		{
		case ev_mouse:

			switch (e.mouse.event)
				{
				case mb_move:

					grBlitString(0,grMaxy-10,grBLACK,"MouseX:  %d",mouse.x);
					grBlitString(0,grMaxy-20,grBLACK,"MouseY:  %d",mouse.y);
					break;


				case mb_leftdn:

					grPutFilledRect(100,100,200,200,grRED);
					break;

				case mb_leftauto:

					grPutFilledRect(100,100,200,200,grGREEN);
					break;

				case mb_leftup:

					grPutFilledRect(100,100,200,200,grBLUE);
					break;

				case mb_rightdn:

					grPutFilledRect(200,100,300,200,grRED);
					break;

				case mb_rightauto:

					grPutFilledRect(200,100,300,200,grGREEN);
					break;

				case mb_rightup:

					grPutFilledRect(200,100,300,200,grBLUE);
					break;

				case mb_middledn:

					grPutFilledRect(300,100,400,200,grRED);
					break;

				case mb_middleauto:

					grPutFilledRect(300,100,400,200,grGREEN);
					break;

				case mb_middleup:

					grPutFilledRect(300,100,400,200,grBLUE);
					break;

				}
		}
	}
