//	-------------------------------------------------------------------------
//
//	TestMouse.HPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Darren J. Dwyer
//
//	DESCRIPTION:	This file defines the main program (derived from Program)
//
//	-------------------------------------------------------------------------

#ifndef __rails_hpp
#define __rails_hpp

#include "program.hpp"
#include "palettes.hpp"

//	-------------------------------------------------------------------------
//
//	CLASS:		TestMouse
//	DESC:		The MAIN object which is the "program". See PROGRAM.?PP
//
//	-------------------------------------------------------------------------

class TestMouse : public Program
	{
	public:
		TestMouse(char* init_string,int options)
			: Program("TestMouse",init_string,options) {}

		virtual	void	Init();
		virtual	void	Exit();
		virtual void 	MainLoop();
		virtual	void	Execute();
	};

//	-------------------------------------------------------------------------
//
//	FUNC:		main()
//	DESC:		This is the function called initially.
//				At the moment it:
//					(1) creates our program
//					(2) executes Program::Execute()
//					(5) deletes our program & exits
//
//	-------------------------------------------------------------------------
void main(int argc,char** argv);

#endif