//	-------------------------------------------------------------------------
//
//	TEXTFILE.HPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Darren J. Dwyer
//
//	DESCRIPTION:	This file contains definitions for the TEXTFILE class
//
//	-------------------------------------------------------------------------

#ifndef __textfile_hpp
#define __textfile_hpp

#include "file.hpp"
#include "strings.hpp"

#define textfile_ReadLineFailed		-100
#define textfile_WriteLineFailed	-101

#define TEXTFILE_DEFAULT_LINE_LENGTH 		80

class TextFile : public File
	{
	public:
						TextFile(char* filename);
						TextFile(String* filename);
						TextFile(char* path,char* filename);
						TextFile(String* path,String* filename);

		virtual int 	ReadLine(char* buf,int maxlen = TEXTFILE_DEFAULT_LINE_LENGTH);
		virtual String*	ReadLine(int maxlen = TEXTFILE_DEFAULT_LINE_LENGTH);

		virtual int		WriteLine(char* buf,int maxlen = TEXTFILE_DEFAULT_LINE_LENGTH);

	};

#endif