#ifndef __tiles_hpp
#define __tiles_hpp

#include "vbuffer.hpp"
#include "images.hpp"

// --------------------------------------------------------------------------
//
//	TILE MACROS (BACKWARDS COMPATIBILITY & EASE OF READING)
//
// --------------------------------------------------------------------------

#define	grTileRect(X1,Y1,X2,Y2,TR_COLOR,TILE,METHOD)	\
			grTileRectVirtual(grSCREEN,(X1),(Y1),(X2),(Y2),(TR_COLOR),\
										(TILE),(METHOD))

// --------------------------------------------------------------------------
//
//	TILE IMPLEMENTATION FUNCTIONS
//
// --------------------------------------------------------------------------


// ---	tiles an image into a virtual buffer using
//		the specified transparency color (-1 == not transparent)
//		and the following methods

// mutually exclusive
#define	NO_ROTATE		0x00000001	// image is tiled 'as is'
#define	AUTO_ROTATE		0x00000002	// image is rotated 90 degrees between
									// each placement

// or'd
#define	GLOBAL			0x00000010	// image is placed relative to global
									// coordinate 0,0

//		NOTE: NO_ROTATE is the only method written at this time

void 	grTileRectVirtual(grVB* vb,
						int x1,int y1,int x2,int y2,
						int tr_color,
						grImage* tile,
						int method );

#endif