#include "stddefns.hpp"
#include "economy.hpp"
#include "railroad.hpp"

char    MIN_STOCK = 0;
char    MAX_STOCK = 0;
char    MIN_BOND  = 0;
char    MAX_BOND  = 0;

char    STOCKS_ON_MARKET = 0;
char	BONDS_ON_MARKET	 = 0;


void	CalcMinStock()
	{
	int minimum = 100000;
	for (int rr=0; rr<NUM_RRS; rr++)
		if (RAILROAD[rr].StockPrice[RAILROAD[rr].CurrentHistory]<minimum)
			{
			minimum = RAILROAD[rr].StockPrice[RAILROAD[rr].CurrentHistory];
			MIN_STOCK = rr;
			}
	}

void	CalcMaxStock()
	{
	int maximum = 0;
	for (int rr=0; rr<NUM_RRS; rr++)
		if (RAILROAD[rr].StockPrice[RAILROAD[rr].CurrentHistory]>maximum)
			{
			maximum = RAILROAD[rr].StockPrice[RAILROAD[rr].CurrentHistory];
			MAX_STOCK = rr;
			}
	}

void	CalcMinBond()
	{
	int minimum = 100000;
	for (int rr=0; rr<NUM_RRS; rr++)
		if (RAILROAD[rr].BondPrice[RAILROAD[rr].CurrentHistory]<minimum)
			{
			minimum = RAILROAD[rr].BondPrice[RAILROAD[rr].CurrentHistory];
			MIN_BOND = rr;
			}
	}

void	CalcMaxBond()
	{
	int maximum = 0;
	for (int rr=0; rr<NUM_RRS; rr++)
		if (RAILROAD[rr].BondPrice[RAILROAD[rr].CurrentHistory]>maximum)
			{
			maximum = RAILROAD[rr].BondPrice[RAILROAD[rr].CurrentHistory];
			MAX_BOND = rr;
			}
	}

void	CalcStocksOnMarket()
	{
	STOCKS_ON_MARKET = 0;
	for (int rr=0; rr<NUM_RRS; rr++)
		if (RAILROAD[rr].StocksOnMarket>0) STOCKS_ON_MARKET++;
	}

void	CalcBondsOnMarket()
	{
	BONDS_ON_MARKET = 0;
	for (int rr=0; rr<NUM_RRS; rr++)
		if (RAILROAD[rr].BondsOnMarket>0) BONDS_ON_MARKET++;
	}

void	CalcEconomyVars()
	{
	int min_stock = 100000;
	int max_stock = 0;
	int min_bond = 100000;
	int max_bond = 0;

	STOCKS_ON_MARKET = 0;
	BONDS_ON_MARKET = 0;

	for (int rr=0; rr<NUM_RRS; rr++)
		{
		if (RAILROAD[rr].StockPrice[RAILROAD[rr].CurrentHistory]<min_stock)
			{
			min_stock = RAILROAD[rr].StockPrice[RAILROAD[rr].CurrentHistory];
			MIN_STOCK = rr;
			}
		if (RAILROAD[rr].StockPrice[RAILROAD[rr].CurrentHistory]>max_stock)
			{
			max_stock = RAILROAD[rr].StockPrice[RAILROAD[rr].CurrentHistory];
			MAX_STOCK = rr;
			}

		if (RAILROAD[rr].BondPrice[RAILROAD[rr].CurrentHistory]<min_bond)
			{
			min_bond = RAILROAD[rr].BondPrice[RAILROAD[rr].CurrentHistory];
			MIN_BOND = rr;
			}
		if (RAILROAD[rr].BondPrice[RAILROAD[rr].CurrentHistory]>max_bond)
			{
			max_bond = RAILROAD[rr].BondPrice[RAILROAD[rr].CurrentHistory];
			MAX_BOND = rr;
			}

		if (RAILROAD[rr].StocksOnMarket>0) STOCKS_ON_MARKET++;
		if (RAILROAD[rr].BondsOnMarket>0) BONDS_ON_MARKET++;
		}
	}

