//	-------------------------------------------------------------------------
//
//	ECONOMY.HPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:		Darren J. Dwyer
//
//	DESCRIPTION:	These are the definitions for the ECONOMY
//
//	-------------------------------------------------------------------------

#ifndef __economy_hpp
#define __economy_hpp

#include "stddefns.hpp"
#include "gamedefn.hpp"

// ECONOMY LEVELS

#define		Panic			0
#define 	Recession		1
#define		Depression		2
#define		Normal			3
#define     Good			4
#define		Great			5
#define		Boom			6

// GLOBALS

extern	char	MIN_STOCK;	// rr which is the minimum stock price
extern	char	MAX_STOCK;
extern	char	MIN_BOND;
extern	char	MAX_BOND;

extern	char	STOCKS_ON_MARKET;	// # of RRS with stocks on market
extern	char	BONDS_ON_MARKET;	// # of RRS with bonds on market

// FUNCTIONS

void	CalcMinStock();
void	CalcMaxStock();
void	CalcMinBond();
void	CalcMaxBond();

void	CalcStocksOnMarket();
void	CalcBondsOnMarket();

void	CalcEconomyVars();

#endif
