//
//	GAMEDEFN.CPP
//

#include "gamedefn.hpp"

// FUNNY TASKS

int		evhno_SetupScreen = 0;

// BACKGROUND TASKS

int		evhno_System = 0;
int 	evhno_Interface = 0;
int		evhno_AI = 0;
int		evhno_GameProcessor = 0;

// ONSCREEN TASKS

int 	evhno_StatusBar = 0;
int		evhno_PlayerActionsBar = 0;
int		evhno_RRActionsBar = 0;
int		evhno_PlayerInfoBar = 0;
int		evhno_RRInfoBar = 0;
int		evhno_MapWin = 0;
int		evhno_OpponentInfo = 0;
int		evhno_MessageWin = 0;

int		evhno_WhichRR = 0;
int		evhno_WhichRoute = 0;
int		evhno_WhichCity = 0;
int		evhno_HowMany = 0;
int		evhno_TrainConfig = 0;

int		evhno_MarketBox = 0;

// OTHER BITS

bool	RANDOM_GAME		= true;

char	CURRENT_PLAYER	= 0;
char	CURRENT_RR		= 0;
long	CURRENT_DATE	= 0;
char	CURRENT_ECONOMY	= 0;
char	LOAN_RATE[4]	= { 0,0,0,0 };


int		GAME_TICKER		= 0;
int		GAME_DELAY		= 0;

// FONTS

int	SYSTEMFONT = 0;		// used for debugging purposes
int	BASICFONT = 0;		// the 'all-the-time' font
int	TITLEFONT = 0;		// used when displaying pretty titles, etc.
int	NEWSPAPERFONT = 0;	// meant for newspaper headings, etc.
int	TINYFONT = 0;		// used for stockmarket titles, etc.
int	HUGEFONT = 0;
int	SETUPFONT = 0;

// MISCELLANEOUS

char*	railroadnames[] =
	{
	"Atlanta & Chattanooga",		"ATL & CH",
	"Atlantic & Great Western",		"ATL & GW",
	"Atlantic & Pacific",			"ATL PAC",
	"Alabama & Tennessee",			"AL & TENN",
	"Atlanta & West Point",			"ATL & WP",
	"Atchison, Topeka & Santa Fe",	"AT & SF",
	"Boston & Albany",				"B & A",
	"Boston & Hartford",			"B & H",
	"Boston & Maine",				"B & M",
	"Baltimore & Ohio",				"B & O",

	"Blue Ridge Line",				"BLUE RDGE",
	"Camden & Amboy",				"C & A",
	"Cincinnati & Chicago",			"CI & CH",
	"Chicago & Eastern Illinois",	"C & EI",
	"Charleston & Hamburg",			"C & H",
	"Chesapeake & Ohio",			"C & O",
	"Chicago & Northwestern",		"C & NW",
	"Colorado & Southern",			"C & S",
	"Chicago, Alton & St. Louis",	"CA & SL",
	"Chicago, Burlington & Quincy",	"CB & Q",

	"Central New Jersey",			"CNJ",
	"Chicago North Shore",			"CNS",
	"Central of Georgia",			"C OF G",
	"Central Pacific",				"CEN PAC",
	"Chicago, Rock Is. & Pacific",	"CRI & P",
	"Central Texas",				"CEN TEX",
	"Denver Pacific",				"DEN PAC",
	"Denver & Rio Grande Western",	"D & RGW",
	"Erie Lackawanna",				"ERIE",
	"Florida East Coast",			"FEC",

	"Ft. Wayne & Chicago",			"FT W & CH",
	"Ft. Worth & Denver",			"FT W & D",
	"Greenville & Columbia",		"GR & CO",
	"Gulf, Mobile & Ohio",			"GM & O",
	"Great Northern",				"GT NTHN",
	"Grand Trunk",					"GR TRNK",
	"Grand Trunk Western",			"GR TRNK W",
	"Great Western",				"GT WSTN",
	"Houston & Shreveport",			"HO & SH",
	"Hudson River Line",			"HRL",

	"Illinois Central",				"ILL CEN",
	"Kansas City & Denver",			"KC & D",
	"Kansas City Northern",			"KC NTHN",
	"Kansas City Southern",			"KC STHN",
	"Kansas Pacific",				"KAN PAC",
	"Louisiana & Arkansas",			"L & A",
	"Louisville & Nashville",		"L & N",
	"Levenworth, Pawnee & Western",	"LP & W",
	"Little Rock & Shreveport",		"LR & SH",
	"Lake Shore",					"LK SHOR", };


char* citynames[] =
	{
	"Atlanta", "Baltimore", "Birmingham", "Boston", "Buffalo",
	"Butte", "Calgary", "Charleston", "Chicago", "Cleveland",
	"Cincinatti", "Denver", "Detroit", "Duluth", "Ft. Worth",
	"Houston", "Juarez", "Kansas City", "London", "Los Angeles",
	"Louisville", "Memphis", "Mexicali", "Mobile", "Monterey",
	"Montreal", "New Orleans", "New York", "Norfolk", "Omaha",
	"Pensacola", "Philadelphia", "Phoenix", "Pittsburgh", "Portland",
	"Quebec", "Sacramento", "Salt Lake City", "San Francisco", "Santa Fe",
	"Sault Ste. Marie", "Savannah", "Seattle", "Spokane", "St. Louis",
	"St. Paul", "Vancouver", "Vicksburg", "Washington", "Wilmington",
	"Winnipeg"
	};

char* playernames[] =
	{
	"Jay Cooke","Erastus Corning","Stephen Douglas","Dan Drew",
	"Thomas Durant","Henry Farham","Jim Fisk","John Forbes",
	"Jay Gould","Edward Harriman","Jim Hill","Cyrus Holliday",
	"Collis Huntington","Byron Kilbourn","Hannibal Kimbail","Milton Littlefield",
	"Louis McLane","J. Piermont Morgan","William Ogden","William Palmer",
	"Robert Shulyer","Thomas Scott","Leland Stanford","J. Edgar Thompson",
	"Cornelius Vanderbilt"
	};

char* econstr[]		= { "Panic","Depression","Recession","Normal",
						"Good Times","Great Times","Boom Times" };

char* monthstr[] 	= { "January","February","March","April","May","June",
						"July","August","September","October","November","December" };

char* daystr[] 		= { "Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday" };

char* dayextstr[] 	= { "1st","2nd","3rd","4th","5th","6th","7th","8th","9th","10th",
						"11th","12th","13th","14th","15th","16th","17th","18th","19th",
						"20th","21st","22nd","23rd","24th","25th","26th","27th","28th",
						"29th","30th","31st" };

char  daysinmonth[] = { 31,28,31,30,31,30, 31,31,30,31,30,31 };


ActionHeaderStruct		ACTION_HEADER;
ResponseHeaderStruct	RESPONSE_HEADER[MAX_RESPONSES];
int						NEXT_RESPONSE = 0;
