#include "player.hpp"
#include "graphics.hpp"
#include "gamedefn.hpp"
#include "railroad.hpp"

char	NUM_PLAYERS;
PlayerStruct PLAYER[MAX_PLAYERS];


void CreateRandomPlayers()
	{
	// create random player stats
	for (int pl=0;pl<NUM_PLAYERS;pl++)
		{
		DBG(470,"Creating Random Player %d",pl);

		PLAYER[pl].Status		= NOT_IN_GAME;
		PLAYER[pl].Name 		= playernames[pl % NUM_HISTORIC_PLAYERS];
		PLAYER[pl].Cash			= 100;

		for (int rr=0;rr<MAX_RRS;rr++)
			{
			PLAYER[pl].Stocks[rr] = 0;
			PLAYER[pl].Bonds[rr] = 0;
			}
		PLAYER[pl].TotalStocks	= 0;
		PLAYER[pl].TotalBonds	= 0;

		for (int loan=0;loan<MAX_LOANS;loan++)
			{
			PLAYER[pl].LoanDue[loan] = 0;
			PLAYER[pl].LoanAmount[loan] = 0;
			PLAYER[pl].LoanRate[loan] = 0;
			}
		PLAYER[pl].TotalLoans = 0;

		PLAYER[pl].TotalSubsid = 0;
		PLAYER[pl].TotalPres = 0;
		PLAYER[pl].TotalAssets = 0;
		PLAYER[pl].TotalDebt = 0;

		PLAYER[pl].ActingForRR = false;

		PLAYER[pl].NETWORK_TYPE = SINGLE_PLAYER;
		}
	}

void	CreateHistoricPlayers()
	{
	CreateRandomPlayers();
	}


int		player_BuyStocks(int player)
	{
	int rr = PLAYER[player].BUYSTOCKS.RR;
	int howmany = PLAYER[player].BUYSTOCKS.Amount;
	int msg = msgBoughtStocks;

	if (howmany>RAILROAD[rr].StocksOnMarket)
		{
		msg = msgCantBuyAllStocks;
		howmany = RAILROAD[rr].StocksOnMarket;
		}

	long cost = RAILROAD[rr].StockPrice[RAILROAD[rr].CurrentHistory] * howmany;

	if (cost>PLAYER[player].Cash)
		{
//		msg = msgOverExtendedStocks;
		}

	RAILROAD[rr].StocksOnMarket -= howmany;
	RAILROAD[rr].StocksInPlayer += howmany;

	PLAYER[player].Stocks[rr] += howmany;
	PLAYER[player].Cash -= RAILROAD[rr].StockPrice[RAILROAD[rr].CurrentHistory] * howmany;

	RAILROAD[rr].StockPrice[RAILROAD[rr].CurrentHistory]++;

	return msg;
	}

int		player_SellStocks(int player)
	{
	int rr = PLAYER[player].SELLSTOCKS.RR;
	int howmany = PLAYER[player].SELLSTOCKS.Amount;

	RAILROAD[rr].StocksOnMarket += howmany;
	RAILROAD[rr].StocksInPlayer -= howmany;

	PLAYER[player].Stocks[rr] -= howmany;
	PLAYER[player].Cash += RAILROAD[rr].StockPrice[RAILROAD[rr].CurrentHistory] * howmany;

	RAILROAD[rr].StockPrice[RAILROAD[rr].CurrentHistory]--;

	return msgSoldStocks;
	}

int		player_BuyBonds(int player)
	{
	int rr = PLAYER[player].BUYBONDS.RR;
	int howmany = PLAYER[player].BUYBONDS.Amount;

	RAILROAD[rr].BondsOnMarket -= howmany;
	RAILROAD[rr].BondsInPlayer += howmany;

	PLAYER[player].Bonds[rr] += howmany;
	PLAYER[player].Cash -= RAILROAD[rr].BondPrice[RAILROAD[rr].CurrentHistory] * howmany;

	return msgBoughtBonds;
	}

int		player_SellBonds(int player)
	{
	int rr = PLAYER[player].SELLBONDS.RR;
	int howmany = PLAYER[player].SELLBONDS.Amount;

	RAILROAD[rr].BondsOnMarket += howmany;
	RAILROAD[rr].BondsInPlayer -= howmany;

	PLAYER[player].Bonds[rr] -= howmany;
	PLAYER[player].Cash += RAILROAD[rr].BondPrice[RAILROAD[rr].CurrentHistory] * howmany;

	return msgSoldBonds;
	}

int		player_GetLoan(int player,int howmuch,int rate,int period)
	{
	return 0;
	}

int		player_RepayLoan(int player,int loannum)
	{
	return 0;
	}

int		player_SpyOnPlayer(int player,int other_player)
	{
	return 0;
	}

int		player_DealWithPlayer(int player,int other_player,int deal)
	{
	return 0;
	}

int		player_SpyOnRR(int player,int rr)
	{
	return 0;
	}

int		player_ControlRR(int player)
	{
	int rr = PLAYER[player].CONTROLRR.RR;

	int total_stocks = RAILROAD[rr].StocksInPlayer +
					   RAILROAD[rr].StocksOnMarket;

	int fifty_percent = total_stocks / 2;

	if (PLAYER[player].Stocks[rr] > fifty_percent)
		{
		RAILROAD[rr].President = player;
		return msgControlledRR;
		}
	return msgCantControlRR;
	}

int		player_ResignControlRR(int player,int rr)
	{
	if (RAILROAD[rr].President == player)
		{
		RAILROAD[rr].President = -1;
		return 0;
		}

	return 1;
	}

int		player_GiveRRLoan(int player,int rr,int howmuch)
	{
	return 0;
	}

int		player_RecallRRLoan(int player,int rr,int howmuch)
	{
	return 0;
	}

int 	player_IncorporateRR(int player,char* rrname,int starting_cash)
	{
	return 0;
	}

int		player_MergeRRs(int player,int rr0,int rr1)
	{
	return 0;
	}

int		player_ActForRR(int player,int rr)
	{
	return 0;
	}
