//	-------------------------------------------------------------------------
//
//	GAMEPROC.HPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Darren J. Dwyer
//
//	DESCRIPTION:	This is the Game Processor.
//
//	-------------------------------------------------------------------------

#ifndef __gameproc_hpp
#define __gameproc_hpp

#include "backgrnd.hpp"
#include "player.hpp"
#include "railroad.hpp"

class GameProcessor : public BackgroundTask
	{
	private:
		int		ticker_cnt;
		int 	player;
		int		rr;

		void	UpdateTime();

		void	UpdateRRHistory();

		void	RunTrains();
		void	ThinkForAI();
		void	UpdateCities();

		void	CheckBankLoans();
		void	CheckNewsReports();

		void	PerformQuickActions();
		void	PerformDailyActions();

		void	SendPlayerResult(int player,int action,int result);
		void	SendRRResult(int rr,int action,int result);

	public:
		GameProcessor();

		virtual void 	HandleEvent(Event &e);
	};

#endif

