//	-------------------------------------------------------------------------
//
//	SUBSID.HPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Darren J. Dwyer
//
//	DESCRIPTION:	These are all of the bits required for subsidiaries
//
//	-------------------------------------------------------------------------

#ifndef __subsid_hpp
#define __subsid_hpp

#include "stddefns.hpp"
#include "gamedefn.hpp"

// DEFINITIONS

#define	SMALL_HOUSE		0	// the different subsidiary types
#define MEDIUM_HOUSE	1
#define	LARGE_HOUSE		2

#define	TIMBER_MILL		3
#define	PAPER_MILL		4
#define	STEEL_MILL		5
#define	MEAT_WORKS		6
#define	POWER_PLANT		7

#define	NOT_OWNED		0  	// subsidiary status
#define	PLAYER_OWNED	1
#define	RR_OWNED		2

struct	SubsidStuct
	{
	char	Status;			// the status of the subsidiary
	char	Owner;			// the owner of the subsidiary

	char	SubsidType;		// the type of subsidiary

	int		x;				// the x position of the subsidiary
	int		y;				// the y position of the subsidiary

	int		Supply;			// the bits produced by this subsidiary
	int		Demand;			// the bits used by this subsidiary??
	};


// GLOBALS

// FUNCTIONS

#endif