//	-------------------------------------------------------------------------
//
//	BANKBOX.CPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Darren J. Dwyer
//
//	DESCRIPTION:	This is the BankBox code
//
//	-------------------------------------------------------------------------

#include "bankbox.hpp"
#include "gamedefn.hpp"
#include "uidefn.hpp"
#include "eventmgr.hpp"
#include "fonts.hpp"
#include "mapwin.hpp"
#include "timer.hpp"
#include "bankfold.hpp"

// -----------------

#include "player.hpp"
#include "railroad.hpp"
#include "route.hpp"

// -----------------

#include "conio.h"
#include "stdio.h"
#include "dos.h"

// -----------------

BankBox*			BANK_BOX;
int					evhno_BankBox;


// -----------------

BankBox::BankBox()
	: FolderBox(bankbox_r.left,bankbox_r.top,
				 bankbox_r.right,bankbox_r.bottom,
				 &evhno_BankBox,&evhno_BankFolder,OTHER_INFO_BOX,"Bank Loans")
	{
	// setup bits for this object
	BANK_BOX = this;
	}

// -----------------

void	BankBox::DrawContents()
	{
	if (!vb) return;

	grSetFont(BASICFONT);

	grDrawLineVirtual(vb,0,20,vb_maxx,20,box_border);
	grDrawLineVirtual(vb,80,20,80,vb_maxy,box_border);
	grDrawLineVirtual(vb,160,20,160,vb_maxy,box_border);
	grDrawLineVirtual(vb,240,20,240,vb_maxy,box_border);

	grDraw2CStringVirtual(vb,20,20,box_title_text,"Amount");
	grDraw2CStringVirtual(vb,100,20,box_title_text,"Rate");
	grDraw2CStringVirtual(vb,180,20,box_title_text,"Date Due");

	int y = 40;
	for (int i=0;i<PLAYER[CURRENT_PLAYER].TotalLoans;i++)
		{
		int	val	 = PLAYER[CURRENT_PLAYER].LoanAmount[i];
		int mill = val / 1000;
		int thou = val % 1000;

		if (mill) grDraw2CStringVirtual(vb,20,y,box_text,"$%d,%.3d,000",mill,thou);
		else      grDraw2CStringVirtual(vb,20,y,box_text,"$%d,000",thou);

		val 	= PLAYER[CURRENT_PLAYER].LoanRate[i];
		mill	= val / 1000;
		thou	= val % 1000;

		if (mill) grDraw2CStringVirtual(vb,100,y,box_text,"$%d,%.3d,000",mill,thou);
		else	  grDraw2CStringVirtual(vb,100,y,box_text,"$%d,000",thou);

		// draw the current date
		int	dayofweek,date,month,year;
		UNPACKDATE(PLAYER[CURRENT_PLAYER].LoanDue[i],dayofweek,date,month,year);

		grDraw2CStringVirtual(vb,180,y,box_text,"%s, %s %s %.4d",
			daystr[dayofweek],dayextstr[date],monthstr[month],year);

		y+=20;
		}
	}

// -----------------

void 	BankBox::HandleEvent(Event &e)
	{
	// handle buttons, etc.
	FolderBox::HandleEvent(e);

	// react to button responses only!!
	switch (e.what)
		{
		case ev_broadcast:

			switch (e.broadcast.event)
				{
				case cmdDayTick:

					Refresh();
					break;
				}
			break;
		}
	}


