//	-------------------------------------------------------------------------
//
//	BANKFOLD.CPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Darren J. Dwyer
//
//	DESCRIPTION:	This is the Bank Folder code
//
//	-------------------------------------------------------------------------

#include "bankfold.hpp"
#include "uidefn.hpp"
#include "gamedefn.hpp"
#include "fonts.hpp"
#include "player.hpp"
#include "bankbox.hpp"

// -----------------

#include "buttons.hpp"
#include "guidefn.hpp"

// -----------------

BankFolder*		BANK_FOLDER;
int				evhno_BankFolder;

// -----------------

BankFolder::BankFolder()
	: Folder(&evhno_BankFolder,"Bank Of America",ac_PlayerFolder|ac_HasInfoBox,BANK_BOX)
	{
	BANK_FOLDER = this;

	int width = r.right-r.left+1;
	int height = r.bottom-r.top+1;

	int x1 = width - 8 - 60;
	int x2 = x1 - 8 - 20;

	AddAccessory(new PictureButton(x1,28,0,
				GUI_BUTTONS[BORROW_BUTTON],
				GUI_BUTTONS[BORROW_BUTTON+1],0,cmdGetLoan));
	AddAccessory(new PictureButton(x1,72,0,
				GUI_BUTTONS[REPAY_BUTTON],
				GUI_BUTTONS[REPAY_BUTTON+1],0,cmdRepayLoan));

	// adjust pics in infobox button
	PictureButton* infobox_button = (PictureButton*) accessory[box_button];
	infobox_button->SetPics(GUI_BUTTONS[OPEN_LOAN_PORTFOLIO_BUTTON],
							GUI_BUTTONS[CLOSE_LOAN_PORTFOLIO_BUTTON]);

	box_open = true;
	}

// -----------------

void	BankFolder::DrawContents()
	{
	// draw basic folder

	Folder::DrawContents();

	// --- draw bank rates box

	// figure size of box

	int x1 = r.left + 8;
	int y1 = r.top + 28;
	int x2 = r.right -  8 - 60 - 8;
	int y2 = r.bottom - 8;

	// draw title area

	grDrawFilledRect(x1+1,y1+1,x2-1,y1+19,folder_title_bg);
	grDrawLine(x1,y1,x1,y1+19,folder_border);		// lhs
	grDrawLine(x2,y1,x2,y1+19,folder_border);		// rhs
	grDrawLine(x1,y1,x2,y1,folder_border);			// top
	grDrawLine(x1,y1+19,x2,y1+19,folder_border);	// bottom

	// draw rate display area

	grDrawFilledRect(x1+1,y1+20+1,x2-1,y2-1,folder_title_bg);

	grDrawRect(x1,y1+20,x2,y2,folder_border);			// border
	grDrawLine(x1+100,y1+20,x1+100,y2,folder_border);	// vert
	grDrawLine(x1+200,y1+20,x1+200,y2,folder_border);	// vert
	grDrawLine(x1+300,y1+20,x1+300,y2,folder_border);	// vert

	// draw text

	grSetFont(BASICFONT);

	grDraw2CString(x1+20,y1,folder_title_text,"Interest Rates");

	grDraw2CString(x1+20,y1+20,grWHITE,"1 Year");
	grDraw2CString(x1+120,y1+20,grWHITE,"2 Year");
	grDraw2CString(x1+220,y1+20,grWHITE,"5 Year");
	grDraw2CString(x1+320,y1+20,grWHITE,"10 Year");

	grDraw2CString(x1+20,y1+40,grWHITE,"%d.%d %%",LOAN_RATE[0]/10,LOAN_RATE[0]%10);
	grDraw2CString(x1+120,y1+40,grWHITE,"%d.%d %%",LOAN_RATE[1]/10,LOAN_RATE[1]%10);
	grDraw2CString(x1+220,y1+40,grWHITE,"%d.%d %%",LOAN_RATE[2]/10,LOAN_RATE[2]%10);
	grDraw2CString(x1+320,y1+40,grWHITE,"%d.%d %%",LOAN_RATE[3]/10,LOAN_RATE[3]%10);
	}

// -----------------

void 	BankFolder::HandleEvent(Event &e)
	{
	// handle buttons, etc.
	Folder::HandleEvent(e);
	}
