//	-------------------------------------------------------------------------
//
//	BNDSFOLD.HPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Darren J. Dwyer
//
//	DESCRIPTION:	This is the Bond Holdings Folder definition
//
//	-------------------------------------------------------------------------

#ifndef __bndsfold_hpp
#define __bndsfold_hpp

#include "folder.hpp"
#include "scrolbox.hpp"

// -----------------

class BondsFolder : public Folder
	{
	public:
						BondsFolder();

		virtual	void	SetBigMode();
		virtual	void	SetSmallMode();

		virtual void 	HandleEvent(Event &e);
	};


// -----------------

extern	BondsFolder*	BONDS_FOLDER;
extern	int				evhno_BondsFolder;

// -----------------

class	BondsScrollBox : public ScrollBox
	{
	public:
		BondsScrollBox(int x1,int y1,int x2,int y2,
						int rows,int maxrows,
						int options,
						int hit_row_event,int hit_hi_row_event);

		//	--- draw functions

		virtual	void	DrawRow(int row,bool auto_fill=true);
		virtual	void	DrawHighlightedRow(int row,bool auto_fill=true);

		virtual void	DrawTitle();
		virtual	void	DrawRowContents(int row,bool is_highlighted);
	};

// -----------------

#endif

