//	-------------------------------------------------------------------------
//
//	ECONBAR.CPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Darren J. Dwyer
//
//	DESCRIPTION:	This is the Economy Bar code
//
//	-------------------------------------------------------------------------

#include "econbar.hpp"
#include "gamedefn.hpp"
#include "uidefn.hpp"
#include "eventmgr.hpp"
#include "fonts.hpp"
#include "mapwin.hpp"

// -----------------

#include "conio.h"
#include "stdio.h"

// -----------------

EconomyBar*			ECONOMY_BAR;
int					evhno_EconomyBar;

// -----------------

EconomyBar::EconomyBar()
	: InfoBox(econbar_r.left,econbar_r.top,
			  econbar_r.right,econbar_r.bottom,
			  &evhno_EconomyBar,OTHER_INFO_BOX,ALWAYS_ON_MAP,"Economy")
	{
	// enable bits for always on map display
	isOnScreen = true;
	isRespondingKbd = false;
	isRespondingMouse = false;

	// setup bits for this object
	ECONOMY_BAR = this;
	last_date = -1;
	last_economy = -1;

	centre_x = (r.right-r.left+1)/2;
	centre_y = (r.bottom-r.top+1)/2;

	SetColors();
	}

// -----------------

void	EconomyBar::DrawBox()
	{
	if (!isOnScreen) return;
	if (!vb) return;

	grDrawFilledRectVirtual(vb,0,0,vb_maxx,vb_maxy,grBLACK);
	}

// -----------------

void	EconomyBar::DrawTitle()
	{
	}

// -----------------

void	EconomyBar::DrawContents()
	{
	if (!isOnScreen) return;
	if (!vb) return;
	if (!MAPWIN->isOnScreen) return;

	DrawDate();
	DrawEconomy();
	}

// -----------------

void	EconomyBar::DrawDate()
	{
//	if (CURRENT_DATE != last_date)
		{
		grSetFont(TITLEFONT);

		// draw the current date
		int	dayofweek,date,month,year;
		UNPACKDATE(CURRENT_DATE,dayofweek,date,month,year);

		char buf[255];

		sprintf(buf,"%s, %s %s %.4d",daystr[dayofweek],dayextstr[date],monthstr[month],year);

		int x = centre_x - grFontWidth(buf)/2;

		grDraw2CStringVirtual(vb,x,0,DATE_TEXT_COLOR,"%s",buf);

		last_date = CURRENT_DATE;
		last_date_x = x;
		}
	}

// -----------------

void	EconomyBar::DrawEconomy()
	{
//	if (CURRENT_ECONOMY != last_economy)
		{
		grSetFont(TITLEFONT);

		char buf[255];

		sprintf(buf,"%s",econstr[CURRENT_ECONOMY]);

		int x = centre_x - grFontWidth(buf)/2;
		grDraw2CStringVirtual(vb,x,20,ECONOMY_TEXT_COLOR,"%s",buf);

		last_economy = CURRENT_ECONOMY;
		last_economy_x = x;
		}
	}

// -----------------

void 	EconomyBar::HandleEvent(Event &e)
	{
	// handle buttons, etc.
	InfoBox::HandleEvent(e);

	// react to button responses only!!
	switch (e.what)
		{
		case ev_broadcast:

			switch (e.broadcast.event)
				{
				case cmdDayTick:

					Refresh();
					break;
				}

			EVENTMGR->ClearEvent(e);
			return;
		}
	}


