//	-------------------------------------------------------------------------
//
//	FOLDRBOX.CPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Darren J. Dwyer
//
//	DESCRIPTION:	This is the generic FolderInfoBox code
//
//	-------------------------------------------------------------------------

#include "foldrbox.hpp"
#include "uidefn.hpp"
#include "gamedefn.hpp"
#include "fonts.hpp"
#include "eventmgr.hpp"
#include "mapwin.hpp"
#include "buttons.hpp"

// -----------------

#include "railroad.hpp"

// -----------------

#include "dos.h"

// -----------------

FolderBox*		FOLDER_BOX = NULL;

// -----------------

FolderBox::FolderBox(int x1,int y1,int x2,int y2,
						int* evhno,int* parent_evhno,int type,char* name)
	: InfoBox(x1,y1,x2,y2,evhno,type,SOMETIMES_ON_MAP,name)
	{
	isOnScreen = false;
	isRespondingKbd = false;

	parent_handler = parent_evhno;

	AddAccessory(new TextButton(0,0,SYSTEMFONT,"CL",0,cmdClose,cmdClose));
	}

// -----------------

FolderBox::~FolderBox()
	{
	DelAllAccessories();
	}

// -----------------

void	FolderBox::Open()
	{
	InfoBox::Open();
	Draw();
	DrawScreenRegion(r.left,r.top,r.right,r.bottom);
	}

// -----------------

void	FolderBox::Close()
	{
	InfoBox::Close();
	MAPWIN->DrawScreenRegion(r.left,r.top,r.right,r.bottom);
	}

// -----------------

void	FolderBox::HandleEvent(Event& e)
	{
	InfoBox::HandleEvent(e);

	switch (e.what)
		{
		case ev_command:

			switch (e.command.event)
				{
				case cmdClose:

					EVENTMGR->ModCommandEvent(e,*parent_handler,cmdCloseFolderBox,NULL);
					break;
				}
			break;
		}
	}

