//	-------------------------------------------------------------------------
//
//	FOLDRSEL.HPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Darren J. Dwyer
//
//	DESCRIPTION:	This is the Folder Selection object
//
//	-------------------------------------------------------------------------

#ifndef __foldrsel_hpp
#define __foldrsel_hpp

#include "infobox.hpp"
#include "resource.hpp"
#include "folder.hpp"
#include "foldrbox.hpp"

// -----------------

#define		MAX_FOLDERS		20

// -----------------

class FolderSelection : public InfoBox
	{
	private:
		ResourceFile*	tab_file;
		grImage** 		tab_icons;

		int				current_folder;

		int				num_folders;
		Folder*			folder_ptr[MAX_FOLDERS];
		FolderBox*		folder_boxptr[MAX_FOLDERS];

	public:
						FolderSelection();
		virtual 		~FolderSelection();

		// (de)register a folder
		void			RegisterFolder(Folder* folder,FolderBox* boxptr);
		void			DeRegisterFolder(Folder* folder);

		// activate & deactivate
		void			Activate(bool refresh=true);
		void			DeActivate();

		// open specified folder
		void			OpenFolder(int folder,bool forced = false);
		void			OpenPrevFolder();
		void			OpenNextFolder();

		// draws all tabs for the tops of the folders
		void			DrawAllTabs();

		// selects an appropriate folder
		virtual void	SelectPrevAccessory();
		virtual void	SelectNextAccessory();
		virtual void	Select(int what);

		// draws all the tabs & thats about it
		virtual void 	Draw();

		// doesn't bother refreshing map underneath
		virtual	void	Refresh();

		// standard
		virtual void 	HandleEvent(Event &e);
	};


// -----------------

extern  FolderSelection*	FOLDER_SELECTION;
extern	int					evhno_FolderSelection;

// -----------------

#endif

