//	-------------------------------------------------------------------------
//
//	GBUTTONS.HPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Darren J. Dwyer
//
//	DESCRIPTION:	These are buttons used in the game
//
//	-------------------------------------------------------------------------

#ifndef __gbuttons_hpp
#define __gbuttons_hpp

#include "buttons.hpp"

// -----------------

class TabButton : public Accessory
	{
	protected:
		grImage*	the_active_pic;
		grImage*	the_inactive_pic;
		int			tr_color;

		bool		isShaded;

	public:
						TabButton(int x1,int y1,
								  grImage* active_pic,grImage* inactive_pic,
								  int transparent_color,
								  int options,int ret_event);

		// modified mouseinside
		virtual bool 	MouseInside(grPoint& p);

		// shades the button or unshades the button
		virtual	void	Shade();
		virtual void	UnShade();

		// sets appropriate pictures 'on the fly' using same draw mode
		virtual void 	SetPic(grImage* active_pic,grImage* inactive_pic,
								int transparent_color);

		// draws the button
		virtual void 	Draw();

		// draws the button into a vb
		virtual void 	Draw(grVirtualBuffer* vb);

		// handleevent
		virtual	void	HandleEvent(Event& e);
		};


// -----------------

/*class	ScrollBox : public Accessory
	{
	public:

						ScrollBox(int x1,int y1,int x2,int y2,
									int num_columns,
									char** column_title,
									char** column_format,
									char** column_data,
									int num_rows,


		virtual	void	Draw();
		virtual	void	Draw(grVirtualBuffer* vb);
		virtual	void	HandleEvent(Event& e);
	};
*/
// -----------------

#endif

