//	-------------------------------------------------------------------------
//
//	GUIDEFN.CPP
//
//	-------------------------------------------------------------------------
//
// 	AUTHOR:		Darren J. Dwyer
//
//	DESC:		These are simple bits and pieces for the game-specific gui
//
//
//	-------------------------------------------------------------------------

#include "guidefn.hpp"
#include "resource.hpp"
#include "program.hpp"

// -----------------

ResourceFile*		GUI_BUTTONS_FILE;
ResourceFile*		GUI_TILES_FILE;

// -----------------

grImage**       	GUI_BUTTONS;
grImage**			GUI_TILES;

// -----------------

void	InitGameUI()
	{
	// open the folder icons file
	GUI_BUTTONS_FILE = new ResourceFile(PROGRAM_PATH,"resource\\buttons.res");
	if (!GUI_BUTTONS_FILE)
		{
		DBG(470,"ERROR (INITGAMEUI): Could not find %sRESOURCE\\buttons.RES",PROGRAM_PATH);
		return;
		}
	// read in all required icons
	GUI_BUTTONS = (grImage**) GUI_BUTTONS_FILE->ReadAllRecords();
	if (!GUI_BUTTONS)
		{
		DBG(470,"ERROR (INITGAMEUI): Could not read RESOURCE\\buttons.RES");
		delete GUI_BUTTONS_FILE;
		return;
		}

	HEAPCHK("InitGameUI():: Just finished GUI_BUTTONS_FILE->ReadAllRecords()");

	GUI_TILES_FILE = new ResourceFile(PROGRAM_PATH,"resource\\tiles.res");
	if (!GUI_TILES_FILE)
		{
		DBG(470,"ERROR (INITGAMEUI): Could not find %sRESOURCE\\TILES.RES");
		return;
		}
	GUI_TILES = (grImage**) GUI_TILES_FILE->ReadAllRecords();
	if (!GUI_TILES)
		{
		DBG(470,"ERROR (INITGAMEUI): Could not read %sRESOURCE\\TILES.RES");
		return;
		}
	HEAPCHK("InitGameUI():: Just finished GUI_TILES_FILE->ReadAllRecords()");
	}

// -----------------

void	ExitGameUI()
	{
	if (GUI_TILES) GUI_TILES_FILE->FreeAllRecords((char**) GUI_TILES);
	if (GUI_TILES_FILE) delete GUI_TILES_FILE;

	if (GUI_BUTTONS) GUI_BUTTONS_FILE->FreeAllRecords((char**) GUI_BUTTONS);
	if (GUI_BUTTONS_FILE) delete GUI_BUTTONS_FILE;
	}

// -----------------
