//	-------------------------------------------------------------------------
//
//	GUIDEFN.HPP
//
//	-------------------------------------------------------------------------
//
// 	AUTHOR:		Darren J. Dwyer
//
//	DESC:		These are simple defines for all the pictures required
//				by the game-specific gui
//
//
//	-------------------------------------------------------------------------

#ifndef __guidefn_hpp
#define __guidefn_hpp

// -----------------

#include "graphics.hpp"

// ---------------- player action buttons

// stksfold

#define	BUY_STOCKS_BUTTON			0
#define	SELL_STOCKS_BUTTON			2
#define	OPEN_STOCKMARKET_BUTTON		4
#define	CLOSE_STOCKMARKET_BUTTON		5

// bndsfold

#define	BUY_BONDS_BUTTON			6
#define	SELL_BONDS_BUTTON			8
#define	OPEN_BONDMARKET_BUTTON		10
#define	CLOSE_BONDMARKET_BUTTON			11

// bankfold

#define	BORROW_BUTTON				12
#define	REPAY_BUTTON				14
#define	OPEN_LOAN_PORTFOLIO_BUTTON	16
#define	CLOSE_LOAN_PORTFOLIO_BUTTON		17

// rrsfold

#define	CONTROL_BUTTON				18
#define	RESIGN_BUTTON				20
#define	MERGE_BUTTON				22
#define	INCORP_BUTTON				24

// spyfold

#define	SPY_PLAYER_BUTTON			26
#define	SPY_RR_BUTTON				28

// ----------------------- railroad actions buttons

// presfold

#define	RR_BORROW_PRES_BUTTON		30
#define	RR_REPAY_PRES_BUTTON		32

// fncefold

#define	RR_BUY_STOCKS_BUTTON		34
#define	RR_SELL_STOCKS_BUTTON		36
#define	RR_BUY_BONDS_BUTTON         38
#define	RR_SELL_BONDS_BUTTON        40

#define RR_BUY_STOCKS_PR_BUTTON		42
#define	RR_SELL_STOCKS_PR_BUTTON	44
#define	RR_BUY_BONDS_PR_BUTTON		46
#define	RR_SELL_BONDS_PR_BUTTON		48

// operfold

#define	RR_REPAY_BUTTON				50
#define	RR_REPAY_DEL_BUTTON			52
#define	RR_SETDIV_BUTTON			54
#define	RR_RAISE_BUTTON				56

// routfold

#define	RR_SURVEY_BUTTON			58
#define	RR_CHARTER_BUTTON			60
#define	RR_BUILD_BUTTON				62

// trnfold

#define	RR_BUILD_TR_BUTTON			64
#define	RR_CONFIG_TR_BUTTON			66
#define	RR_SCRAP_TR_BUTTON			68

// subfold

#define	RR_BLD_SUBSID_BUTTON		70
#define	RR_SELL_SUBSID_BUTTON		72

// ----------------------- game action buttons

#define	ABOUT_BUTTON				74
#define	NEW_BUTTON					76
#define	LOAD_BUTTON					78
#define	SAVE_BUTTON					80
#define	QUIT_BUTTON					82
#define	PLAYER_CONFIG_BUTTON		84

#define	HUGE_SCROLL_LT_BUTTON		86
#define	HUGE_SCROLL_RT_BUTTON		88
#define	HUGE_SCROLL_BUTTON			90

// ----------------------- other folder buttons

#define	OPEN_INFOBOX_BUTTON			92
#define	CLOSE_INFOBOX_BUTTON			93

#define	DONE_BUTTON					94
#define	CANCEL_BUTTON				96

#define	BIG_FOLDER_BUTTON     		98
#define	SMALL_FOLDER_BUTTON				99

#define	SMALL_SCROLL_UP_BUTTON      100
#define	SMALL_SCROLL_DN_BUTTON		102

#define	MEDIUM_SCROLL_UP_BUTTON		104
#define	MEDIUM_SCROLL_DN_BUTTON		106

#define	LARGE_SCROLL_UP_BUTTON		108
#define	LARGE_SCROLL_DN_BUTTON		110

#define	HUGE_SCROLL_UP_BUTTON		112
#define	HUGE_SCROLL_DN_BUTTON		114

// ----------------------- GUI tiles

#define	SCREEN_TILE					0
#define	FOLDER_TILE					1
#define	FOLDER_TITLE_TILE			2
#define	SCROLLBOX_TITLE_TILE		3
#define	SCROLLBOX_LOW_TILE			4
#define	SCROLLBOX_HIGH_TILE			5

// -----------------

extern	grImage**       	GUI_BUTTONS;
extern	grImage**			GUI_TILES;

// -----------------

void	InitGameUI();
void	ExitGameUI();

// -----------------

#endif