//	-------------------------------------------------------------------------
//
//	INFOBOX.HPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Darren J. Dwyer
//
//	DESCRIPTION:	This is the generic Information Box object
//					which sits on top of the map
//
//	-------------------------------------------------------------------------

#ifndef __infobox_hpp
#define __infobox_hpp

#include "onscreen.hpp"

// ----------------- INFOBOX TYPES

#define		PLAYER_INFO_BOX		0
#define		RAILROAD_INFO_BOX	1
#define		OTHER_INFO_BOX		2

// ----------------- INFOBOX MODES

#define		ALWAYS_ON_MAP		0
#define		SOMETIMES_ON_MAP	1

// -----------------

class InfoBox : public OnScreenHandler
	{
	private:
		int				box_type;
		int				box_mode;

		char*			box_name;

		bool			box_registered;     // see: foldrsel.cpp constructor & destructor
		bool			vb_registered;		// see: ^^

	protected:

		int				box_title_bg;
		int				box_title_text;
		int				box_border;
		int				box_bg;
		int				box_text;

		grVirtualBuffer*	vb;

		int				vb_maxx;
		int				vb_maxy;

// -----------------

	public:

						InfoBox( int x1,int y1,int x2,int y2,
								 int* evhno,
								 int type, int mode, char* name );
		virtual 		~InfoBox();

		virtual	void	SetColors();

		virtual	void	DrawBox();		// basic box
		virtual	void	DrawTitle();	// title block (if reqd)
		virtual	void	DrawContents();	// contents of rest of box

		virtual void 	Draw();
		virtual	void	DrawScreenRegion(int x1,int y1,int x2,int y2);

		virtual	void	Refresh();

		virtual	void	Open();
		virtual	void	Close();

		virtual void 	HandleEvent(Event &e);
	};


// -----------------

#endif

