//	-------------------------------------------------------------------------
//
//	BANKBOX.CPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Darren J. Dwyer
//
//	DESCRIPTION:	This is the code for the BANK_BOX
//
//	-------------------------------------------------------------------------

#include "bankbox.hpp"
#include "gamedefn.hpp"
#include "eventmgr.hpp"
#include "buttons.hpp"

#include "player.hpp"
#include "railroad.hpp"
#include "economy.hpp"
#include "msgwin.hpp"

#include "intrface.hpp"

#include "dos.h"	// for delay()

BankBox::BankBox()
	: OnScreenHandler(bankbox_r.left,bankbox_r.top,bankbox_r.right,bankbox_r.bottom,
					  BG_COLOR,bs_NONE,bs_NONE,
					  &evhno_BankBox,0,1)
	{
	isOnScreen = false;
	}

void BankBox::Draw()
	{
	// draw basic window
	grDrawShadedRect(r.left,r.top,r.right,r.bottom,bgcolor,2);
	grDrawRect(r.left,r.top,r.right,r.bottom,grLIGHTGREEN);

	grSetFont(TITLEFONT);
	grDraw2CString(r.left+10,r.top+10,TEXT_COLOR,"BANK OF AMERICA");
	grSetFont(BASICFONT);
	}

void	BankBox::Open()
	{
	if (!isOnScreen)
		{
		isOnScreen = true;

		EVENTMGR->GenCommandEvent(evhno_BankBox,cmdRedraw,NULL);
		}
	}

void	BankBox::Close()
	{
	if (isOnScreen)
		{
		isOnScreen = false;
		}
	}


void BankBox::HandleEvent(Event &e)
	{
	// pre-process cmdOpen & cmdClose
	switch (e.what)
		{
		case ev_command:

			switch (e.command.event)
				{
				case cmdRedraw:

				// NOTE: on Open() underneath box is redrawn initially!!!
					EVENTMGR->GenCommandEvent(evhno_MapWin,cmdRedrawScreenRegion,&r);
					EVENTMGR->GenCommandEvent(evhno_BankBox,cmdRefresh,NULL);
					EVENTMGR->ClearEvent(e);
					break;

				case cmdExternalRefresh:

					Draw();
					EVENTMGR->ClearEvent(e);
					break;

				case cmdOpen:

					Open();
					EVENTMGR->ClearEvent(e);
					return;

				case cmdClose:

					Close();
					if (e.command.data==NULL) EVENTMGR->GenCommandEvent(evhno_MapWin,cmdRefreshScreenRegion,&r);
					else EVENTMGR->GenCommandEvent(evhno_MapWin,cmdRedrawScreenRegion,&r);
					EVENTMGR->ClearEvent(e);
					break;
				}
			break;
		}

	// do all the _boring_ event processing
	OnScreenHandler::HandleEvent(e);
	}
