//	-------------------------------------------------------------------------
//
//	INTRFACE.HPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Darren J. Dwyer
//
//	DESCRIPTION:	This is the UI (user interface) for human players
//
//	-------------------------------------------------------------------------

#ifndef __intrface_hpp
#define __intrface_hpp

#include "backgrnd.hpp"
#include "player.hpp"
#include "railroad.hpp"

extern	int		INFOBOX_MODE;
extern	int		INFOBOX_HANDLER;
extern	int		QUERY_MODE;
extern	int		QUERY_HANDLER;

extern	int		PLAYER_MODE;
extern	int		PLAYER_NETWORK_TYPE;

extern	int		CURRENT_PLAYER;
extern	int		SELECTED_RR;
extern	int		SELECTED_ROUTE;
extern	int		SELECTED_CITY;

class Interface : public BackgroundTask
	{
	private:
		int		orig_infobox_handler;
		int		orig_infobox_mode;

	public:
		Interface();

		void	SetPlayerMode(int player);
		void	SetRRMode(int railroad);

		void	OpenQuery( int handler, int mode );
		void	CloseQuery();

		void	OpenInfoBox( int handler, int mode );
		void	CloseInfoBox();

		void	OpenMessage( int action, int message );
		void	CloseMessage();

		void	SendPlayerAction();
		void	SendRRAction();

		void	DoPlayerResponse( int response_num );
		void	DoRRResponse( int response_num );

		virtual void HandleEvent(Event &e);
	};

#endif

