//	-------------------------------------------------------------------------
//
//	STATUS.CPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Darren J. Dwyer
//
//	DESCRIPTION:	This is the Status Bar
//
//	-------------------------------------------------------------------------

#include "status.hpp"

#include "gamedefn.hpp"

#include "player.hpp"
#include "railroad.hpp"
#include "intrface.hpp"

StatusBar::StatusBar()
	: OnScreenHandler(statusbar_r.left,statusbar_r.top,statusbar_r.right,statusbar_r.bottom,
					  BG_COLOR,bs_NONE,bs_NONE,
					  &evhno_StatusBar,0,1)
	{
	}

void StatusBar::Draw()
	{
	// draw the window background & border
	grDrawWindow(r.left,r.top,r.right,r.bottom,bgcolor,active_bs);

	// draw the player
	if (PLAYER_MODE==MPLAYER)
		{
		int mill = PLAYER[0].Cash / 1000;
		int thou = PLAYER[0].Cash % 1000;
		grDrawString(inset_r.left+2,inset_r.top,"%s",PLAYER[CURRENT_PLAYER].Name);
		if (mill) grDrawString(inset_r.left+202,inset_r.top,"$%d,%.3d,000",mill,thou);
		else grDrawString(inset_r.left+202,inset_r.top,"$%d,000",thou);
		}
	else
		{
		grDrawString(r.left+2,r.top,"%s",RAILROAD[SELECTED_RR].Name);
		}

	// draw the current date
	int	dayofweek,date,month,year;
	UNPACKDATE(CURRENT_DATE,dayofweek,date,month,year);

	grDrawString(r.left+352,r.top,"%s,",daystr[dayofweek]);
	grDrawString(r.left+452,r.top,"%s %s %.4d",dayextstr[date],monthstr[month],year);
	}

void StatusBar::HandleEvent(Event& e)
	{
	OnScreenHandler::HandleEvent(e);

	switch (e.what)
		{
		case ev_broadcast:	

            switch (e.broadcast.event)
				{
				case cmdDayTick:
				case cmdMonthTick:

				case cmdPlayerStatusChanged:
				case cmdPlayerModeChanged:
				case cmdEconomyChanged:
                
					Refresh();
                    break;
				}
			break;
		}
	}
