//	-------------------------------------------------------------------------
//
//	TRAINCFG.HPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Darren J. Dwyer
//
//	DESCRIPTION:	This is the window asking "Configure the Train"
//
//	-------------------------------------------------------------------------

#ifndef __traincfg_hpp
#define __traincfg_hpp

#include "onscreen.hpp"

class TrainConfig : public OnScreenHandler
	{
	private:
		int				selected_check_point;
		int				check_points_entered;

		int 			check_points[4];

		bool			new_train;

		Accessory*		check[4];
		Accessory*		done;
		Accessory*		cancel;

	public:
		TrainConfig();

		virtual void 	Draw();

		virtual	void	Open();
		virtual	void	Close();

		void			HighlightSelectedRoute();

		virtual void 	HandleEvent(Event& e);
	};

#endif

