//	-------------------------------------------------------------------------
//
//	PLYRFOLD.CPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Darren J. Dwyer
//
//	DESCRIPTION:	This is the Player Information Folder code
//
//	-------------------------------------------------------------------------

#include "plyrfold.hpp"
#include "fonts.hpp"
#include "buttons.hpp"
#include "guidefn.hpp"

// -----------------

#include "uidefn.hpp"
#include "gamedefn.hpp"
#include "player.hpp"

// -----------------

PlayerFolder*	PLAYERINFO_FOLDER;
int				evhno_PlayerFolder;

// -----------------

PlayerFolder::PlayerFolder()
	: Folder(&evhno_PlayerFolder,"Player Information",ac_PlayerFolder,NULL)
	{
	isOnScreen = true;
	}

// -----------------

void	PlayerFolder::DrawContents()
	{
	Folder::DrawContents();

	int x1 = r.left + 8;
	int x2 = x1 + 120;
	int y1 = r.top + 28;

	grSetFont(BASICFONT);
	grDraw2CString(x1,y1,folder_text,"Cash In Hand:");

	int val  = PLAYER[CURRENT_PLAYER].Cash;
	int mill = val / 1000;
	int thou = val % 1000;

	if (mill) grDraw2CString(x2,y1,folder_text,"$%d,%.3d,000",mill,thou);
	else      grDraw2CString(x2,y1,folder_text,"$%d,000",thou);


	y1 += 16;

	grDraw2CString(x1,y1,folder_text,"Total Loans:");

	val		= PLAYER[CURRENT_PLAYER].TotalDebt;
	mill	= val / 1000;
	thou	= val % 1000;

	if (mill) grDraw2CString(x2,y1,folder_text,"$%d,%.3d,000",mill,thou);
	else      grDraw2CString(x2,y1,folder_text,"$%d,000",thou);

	y1 += 40;

	grDraw2CString(x1,y1,folder_text,"Net Wealth:");

	val		= PLAYER[CURRENT_PLAYER].TotalAssets - PLAYER[CURRENT_PLAYER].TotalDebt;
	mill	= val / 1000;
	thou	= val % 1000;

	if (mill) grDraw2CString(x2,y1,folder_text,"$%d,%.3d,000",mill,thou);
	else      grDraw2CString(x2,y1,folder_text,"$%d,000",thou);


	x1 = r.left + 300;
	x2 = x1 + 120;
	y1 = r.top + 28;

	grDraw2CString(x1,y1,folder_text,"Stock Holdings:");

	val		= PLAYER[CURRENT_PLAYER].TotalStocks;
	mill	= val / 1000;
	thou	= val % 1000;

	if (mill) grDraw2CString(x2,y1,folder_text,"%d,%.3d,000",mill,thou);
	else      grDraw2CString(x2,y1,folder_text,"%d,000",thou);

	y1 += 16;

	grDraw2CString(x1,y1,folder_text,"Bond Holdings:");

	val		= PLAYER[CURRENT_PLAYER].TotalBonds;
	mill	= val / 1000;
	thou	= val % 1000;

	if (mill) grDraw2CString(x2,y1,folder_text,"%d,%.3d,000",mill,thou);
	else      grDraw2CString(x2,y1,folder_text,"%d,000",thou);

	y1 += 16;

	grDraw2CString(x1,y1,folder_text,"Presidencies:");

	val		= PLAYER[CURRENT_PLAYER].TotalPres;

	grDraw2CString(x2,y1,folder_text,"%d",val);
	}

