//	-------------------------------------------------------------------------
//
//	STKSFOLD.HPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Darren J. Dwyer
//
//	DESCRIPTION:	This is the Stock Holdings Folder definition
//
//	-------------------------------------------------------------------------

#ifndef __stksfold_hpp
#define __stksfold_hpp

#include "folder.hpp"
#include "scrolbox.hpp"

// -----------------

class StocksFolder : public Folder
	{
	public:
						StocksFolder();

		virtual	void	SetBigMode();
		virtual	void	SetSmallMode();

		virtual void 	HandleEvent(Event &e);
	};


// -----------------

extern	StocksFolder*	STOCKS_FOLDER;
extern	int				evhno_StocksFolder;

// -----------------

class	StocksScrollBox : public ScrollBox
	{
	public:
		StocksScrollBox(int x1,int y1,int x2,int y2,
						int rows,int maxrows,
						int options,
						int hit_row_event,int hit_hi_row_event);

		//	--- draw functions

		virtual	void	DrawRow(int row,bool auto_fill=true);
		virtual	void	DrawHighlightedRow(int row,bool auto_fill=true);

		virtual void	DrawTitle();
		virtual	void	DrawRowContents(int row,bool is_highlighted);
	};

// -----------------

#endif

