//
//	UIDEFN.HPP
//
//	Definitions required by the user-interface

#ifndef __uidefn_hpp
#define __uidefn_hpp

#include "stddefns.hpp"
#include "graphics.hpp"

#define UI_DEBUG

// -----------------
// 	SCREEN REGIONS
// -----------------

extern	grRect		map_r;
extern	int			map_width;
extern	int			map_height;

extern	grRect		econbar_r;

extern	grRect		terrinfo_r;
extern	grRect		cityinfo_r;
extern	grRect		routeinfo_r;

extern	grRect		stockmarketbox_r;
extern	grRect		bondmarketbox_r;
extern	grRect		bankbox_r;

// -----------------
// 	FOLDER REGIONS
// -----------------

extern	grRect		folder_select_r;
extern	grRect		folder_r;
extern	grRect		query_r;

// -----------------
// 	FOLDER BITS
// -----------------

#define NUM_FOLDERS						16

// -----------------

#define	NUM_PLAYER_FOLDERS				7

#define cmdSelectPlayerInfoFolder		10001
#define	cmdSelectStockHoldingsFolder	10002
#define	cmdSelectBondHoldingsFolder		10003
#define	cmdSelectBankFolder				10004
#define	cmdSelectRailroadFolder			10005
#define	cmdSelectSpyFolder				10006
#define	cmdSelectOpponentFolder			10007

// -----------------

#define	NUM_RAILROAD_FOLDERS			8

#define	cmdSelectRRInfoFolder			10051
#define	cmdSelectRRPresFolder			10052
#define	cmdSelectRRFinanceFolder		10053
#define	cmdSelectRROperationsFolder		10054
#define	cmdSelectRRRoutesFolder			10055
#define	cmdSelectRRTrainsFolder			10056
#define	cmdSelectRRSubsidFolder			10057
#define	cmdSelectRRProfitLossFolder		10058

// -----------------

#define	NUM_EXTRA_FOLDERS				1

#define	cmdSelectGameFolder				10101

// -----------------

#define	cmdRedrawTabs					10201
#define	cmdRefreshFolder				10202

// -----------------

#define cmdToggleBigMode				10300
#define	cmdToggleInfoBox				10301
#define	cmdCloseFolderBox				10302

// -----------------
// 	COLORS
// -----------------

extern	int		folder_title_border;
extern	int		folder_title_bg;
extern	int		folder_title_text;
extern	int		folder_border;
extern	int		folder_bg;
extern	int		folder_text;

#define	grDARKESTBROWN					64
#define	grLIGHTESTBROWN                 79

#define	PLAYER_TITLE_BG					grLIGHTGRAY
#define	PLAYER_TITLE_TEXT               grRED
#define	PLAYER_BORDER                   grLIGHTGRAY
#define	PLAYER_BG                       grDARKGRAY
#define	PLAYER_TEXT                     grLIGHTGRAY

#define	RAILROAD_TITLE_BG				grCYAN
#define	RAILROAD_TITLE_TEXT             grWHITE
#define	RAILROAD_BORDER                 grLIGHTGRAY
#define	RAILROAD_BG                     grDARKGRAY
#define	RAILROAD_TEXT                   grWHITE

#define	CONTROLLED_TITLE_BG             grCYAN
#define	CONTROLLED_TITLE_TEXT           grWHITE
#define	CONTROLLED_BORDER				grLIGHTGRAY
#define	CONTROLLED_BG                   grDARKGRAY
#define	CONTROLLED_TEXT                 grWHITE

#define	RECEIVERSHIP_TITLE_BG           grCYAN
#define	RECEIVERSHIP_TITLE_TEXT         grWHITE
#define	RECEIVERSHIP_BORDER             grLIGHTGRAY
#define	RECEIVERSHIP_BG                 grDARKGRAY
#define	RECEIVERSHIP_TEXT               grWHITE

#define	REORGANIZING_TITLE_BG           grCYAN
#define	REORGANIZING_TITLE_TEXT         grWHITE
#define	REORGANIZING_BORDER             grLIGHTGRAY
#define	REORGANIZING_BG                 grDARKGRAY
#define	REORGANIZING_TEXT               grWHITE

#define	OTHER_TITLE_BG                  grLIGHTGRAY
#define	OTHER_TITLE_TEXT				grLIGHTRED
#define	OTHER_BORDER					grWHITE
#define	OTHER_BG						grDARKGRAY
#define	OTHER_TEXT						grRED

// -----------------
//  QUERY BITS
// -----------------

extern	int		query_title_bg;
extern	int		query_title_text;
extern	int		query_border;
extern	int		query_bg;
extern	int		query_text;

// -----------------
// 	MAP BITS
// -----------------

#define	cmdTerrainSelected				3000
#define	cmdCitySelected					3001
#define	cmdRouteSelected				3002
#define	cmdTrainSelected				3003

#define	DATE_TEXT_COLOR					grWHITE
#define	ECONOMY_TEXT_COLOR				grWHITE

// -----------------
//	PLAYER BITS
// -----------------

extern	int			CURRENT_PLAYER;

// -----------------
//	RAILROAD BITS
// -----------------

extern	int			CURRENT_RR;

// -----------------
//	SELECTION BITS
// -----------------

extern	int			SELECTED_RR;
extern	int			SELECTED_ROUTE;
extern	int			SELECTED_CITY;
extern	int			SELECTED_TRAIN;

#endif
