//	-------------------------------------------------------------------------
//
//	BASEWIN.HPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Andrew Carvel Evans
//
//	DESCRIPTION:	This is the Base Colour Selection Window
//
//	-------------------------------------------------------------------------

#ifndef __basewin_hpp
#define __basewin_hpp

#include "onscreen.hpp"
#include "grid.hpp"

#include "tooldefn.hpp"

#define		SIZE_OF_NAME			20
#define		NUMBER_OF_BASECOLOURS	255

struct BaseColour
	{
	char	name[SIZE_OF_NAME];

	uchar	red,
			green,
			blue;
	};

class BaseRegion : public OnScreenHandler
	{
	public:
		Grid*		base_grid;
		BaseColour	base[NUMBER_OF_BASECOLOURS];

				BaseRegion();
				~BaseRegion();

		void	AssignBaseColour(int i,char* n,uchar r,uchar g,uchar b);

		void	Draw();
		void	HandleEvent(Event& e);
	};

extern	int				evhno_BaseRegion;
extern	BaseRegion*		basewin;

#endif
