//	-------------------------------------------------------------------------
//
//	BUTWIN.CPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Andrew Carvel Evans
//
//	DESCRIPTION:	This is the Button Window
//
//	-------------------------------------------------------------------------

#include "eventmgr.hpp"
#include "buttons.hpp"
#include "fonts.hpp"

#include "butwin.hpp"
// this window talks to these windows
#include "editwin.hpp"
#include "tilewin.hpp"
#include "thumbwin.hpp"
#include "basewin.hpp"
#include "rangewin.hpp"
// and uses this task
#include "filemgnt.hpp"

int					evhno_BmpButtonRegion;
BmpButtonRegion*	bmpbutwin;

int					evhno_PalButtonRegion;
PalButtonRegion*	palbutwin;

BmpButtonRegion::BmpButtonRegion()
	: OnScreenHandler(max_edit_x2,max_tile_y2,thumb_x1-1,grMaxy,&evhno_BmpButtonRegion,0,1)
	{
	if (screen_mode == GUI_ICONS)	isOnScreen = true;
	else							isOnScreen = false;

	int	width = GUIbitmap[0]->hdr.width,
		height = GUIbitmap[0]->hdr.height;

	// ---------------------------------------------------------------------

	// Disk/System Button creation

	int	x1 = gap,
		x2 = x1 + width,
		x3 = x2 + width,
		x4 = x3 + width,
		x5 = x4 + width,
		y  = gap;

	// first row
	y += grFontHeight();
	AddAccessory(new PictureButton(x1,y,
					GUIbitmap[GUI_SINGLE],GUIbitmap[GUI_SINGLE+1],0,cmdSingle));

	AddAccessory(new PictureButton(x2,y,
					GUIbitmap[GUI_REPEAT],GUIbitmap[GUI_REPEAT+1],0,cmdRepeat));

	AddAccessory(new PictureButton(x3,y,
					GUIbitmap[GUI_TILE],GUIbitmap[GUI_TILE+1],0,cmdTile));

	AddAccessory(new PictureButton(x4,y,
					GUIbitmap[GUI_CLEARTILE],GUIbitmap[GUI_CLEARTILE+1],0,cmdClearTile));

	y += height;
	AddAccessory(new PictureButton(x1,y,
					GUIbitmap[GUI_LOAD],GUIbitmap[GUI_LOAD+1],0,cmdLoad));

	AddAccessory(new PictureButton(x2,y,
					GUIbitmap[GUI_LOADALL],GUIbitmap[GUI_LOADALL+1],0,cmdLoadAll));

	AddAccessory(new PictureButton(x3,y,
					GUIbitmap[GUI_SAVE],GUIbitmap[GUI_SAVE+1],0,cmdSave));

	AddAccessory(new PictureButton(x4,y,
					GUIbitmap[GUI_SAVEALL],GUIbitmap[GUI_SAVEALL+1],0,cmdSaveAll));

	AddAccessory(new PictureButton(x5,y,
					GUIbitmap[GUI_QUIT],GUIbitmap[GUI_QUIT+1],0,cmdExitProgram));

	y += height;
	AddAccessory(new PictureButton(x1,y,
					GUIbitmap[GUI_FILL],GUIbitmap[GUI_FILL+1],0,cmdFill));

	AddAccessory(new PictureButton(x2,y,
					GUIbitmap[GUI_FULLFILL],GUIbitmap[GUI_FULLFILL+1],0,cmdFillImage,cmdClearImage));

	AddAccessory(new PictureButton(x3,y,
					GUIbitmap[GUI_STORE],GUIbitmap[GUI_STORE+1],0,cmdStoreImage));

	AddAccessory(new PictureButton(x4,y,
					GUIbitmap[GUI_GET],GUIbitmap[GUI_GET+1],0,cmdGetImage));

	AddAccessory(new PictureButton(x5,y,
					GUIbitmap[GUI_UNDO],GUIbitmap[GUI_UNDO+1],0,cmdUndo));

	y += height;
	AddAccessory(new PictureButton(x1,y,
					GUIbitmap[GUI_ERASE],GUIbitmap[GUI_ERASE+1],0,cmdErase,cmdFilledErase));

	AddAccessory(new PictureButton(x2,y,
					GUIbitmap[GUI_DRAW],GUIbitmap[GUI_DRAW+1],0,cmdDraw,cmdFilledDraw));

	AddAccessory(new PictureButton(x3,y,
					GUIbitmap[GUI_LINE],GUIbitmap[GUI_LINE+1],0,cmdLine,cmdFlatLine));

	AddAccessory(new PictureButton(x4,y,
					GUIbitmap[GUI_RECT],GUIbitmap[GUI_RECT+1],0,cmdRect,cmdFilledRect));

	AddAccessory(new PictureButton(x5,y,
					GUIbitmap[GUI_ELLIPSE],GUIbitmap[GUI_ELLIPSE+1],0,cmdEllipse,cmdFilledEllipse));

	y += height;
	AddAccessory(new PictureButton(x1,y,
					GUIbitmap[GUI_FLIPX],GUIbitmap[GUI_FLIPX+1],0,cmdFlipHorizontal));

	AddAccessory(new PictureButton(x2,y,
					GUIbitmap[GUI_FLIPY],GUIbitmap[GUI_FLIPY+1],0,cmdFlipVertical));

	AddAccessory(new PictureButton(x3,y,
					GUIbitmap[GUI_ROTATE90],GUIbitmap[GUI_ROTATE90+1],0,cmdRotate90,cmdRotate270));

	AddAccessory(new PictureButton(x4,y,
					GUIbitmap[GUI_ROTATE180],GUIbitmap[GUI_ROTATE180+1],0,cmdRotate180,cmdRotate180));

	AddAccessory(new PictureButton(x5,y,
					GUIbitmap[GUI_ROTATE270],GUIbitmap[GUI_ROTATE270+1],0,cmdRotate270,cmdRotate90));

	// ---------------------------------------------------------------------

	y += height;
	AddAccessory(new PictureButton(x1,y,
					GUIbitmap[GUI_LEFT],GUIbitmap[GUI_LEFT+1],0,cmdScrollLeft,cmdScrollLeftFive));

	AddAccessory(new PictureButton(x2,y,
					GUIbitmap[GUI_TOP],GUIbitmap[GUI_TOP+1],0,cmdScrollUp,cmdScrollUpFive));

	AddAccessory(new PictureButton(x3,y,
					GUIbitmap[GUI_BOTTOM],GUIbitmap[GUI_BOTTOM+1],0,cmdScrollDown,cmdScrollDownFive));

	AddAccessory(new PictureButton(x4,y,
					GUIbitmap[GUI_RIGHT],GUIbitmap[GUI_RIGHT+1],0,cmdScrollRight,cmdScrollRightFive));

	y += height;
	AddAccessory(new PictureButton(x1,y,
					GUIbitmap[GUI_LTARROW],GUIbitmap[GUI_LTARROW+1],0,cmdIncreaseWidthLeft,cmdDecreaseWidthLeft));

	AddAccessory(new PictureButton(x2,y,
					GUIbitmap[GUI_UPARROW],GUIbitmap[GUI_UPARROW+1],0,cmdIncreaseHeightTop,cmdDecreaseHeightTop));

	AddAccessory(new PictureButton(x3,y,
					GUIbitmap[GUI_DNARROW],GUIbitmap[GUI_DNARROW+1],0,cmdIncreaseHeightBottom,cmdDecreaseHeightBottom));

	AddAccessory(new PictureButton(x4,y,
					GUIbitmap[GUI_RTARROW],GUIbitmap[GUI_RTARROW+1],0,cmdIncreaseWidthRight,cmdDecreaseWidthRight));

	y += height;
	AddAccessory(new PictureButton(x1,y,
					GUIbitmap[GUI_PALETTE],GUIbitmap[GUI_PALETTE+1],0,cmdGotoPalette));
	}

BmpButtonRegion::~BmpButtonRegion()
	{
	DelAllAccessories();
	}

void BmpButtonRegion::Draw()
	{
	grDrawFilledRect(r.left,r.top,r.right,r.bottom,grBACKGROUND);

	DrawAllAccessories();

	String*	modestr = new String(50);

	switch (output_fill_mode)
		{
		case NONE:		modestr->Append("No Fill "); break;
		case SOLID:		modestr->Append("Filled  "); break;
		}

	switch (output_draw_mode)
		{
		case ERASE:		modestr->Append(" Erase    "); break;
		case DRAW:		modestr->Append(" Draw     "); break;
		case LINE:		modestr->Append(" Line     "); break;
		case FLATLINE:	modestr->Append(" FlatLine "); break;
		case RECT:		modestr->Append(" Rect     "); break;
		case ELLIPSE:	modestr->Append(" Ellipse  "); break;
		}

	grBlitString(mode_x,mode_y,grBACKGROUND,modestr->Contents());

	delete modestr;

	grBlitRegion(r.left,r.top,r.right,r.bottom);
DBG(470,"Finished bmpbutwin->Draw");
	}

void BmpButtonRegion::HandleEvent(Event& e)
	{
	OnScreenHandler::HandleEvent(e);

	int				x,y;
	bool			handled = false;

	ChooseSingleOrExtendedImage;

	switch (e.what)
		{
		case ev_command:
			switch (e.command.event)
				{
				case cmdLoad:
					if (input_grid_mode == SINGLE)
						filemgr->LoadImage(current_image_index);
					else if (input_grid_mode == EXTENDED)
						{
						for (y=0; y<MAX_TILES_DOWN; y++)
							for (x=0; x<MAX_TILES_ACROSS; x++)
								if (tilewin->tile[x][y])
									filemgr->LoadImage(tilewin->tile[x][y]-1);
						}
					else if (input_grid_mode == EXTENDED_SINGLE)
						filemgr->LoadImage(tilewin->tile[tilewin->tile_selected_x][tilewin->tile_selected_y]-1);

					tilewin->MakeTiledImage();
					editwin->Refresh();
					tilewin->Refresh();
					thumbwin->Refresh();

					handled = true;
					break;

				case cmdLoadAll:
					filemgr->LoadImages();

					tilewin->MakeTiledImage();
					editwin->Refresh();
					tilewin->Refresh();
					thumbwin->Refresh();

					handled = true;
					break;

				case cmdSave:
					if (input_grid_mode == SINGLE)
						filemgr->SaveImage(current_image_index);
					else if (input_grid_mode == EXTENDED)
						{
						for (y=0; y<MAX_TILES_DOWN; y++)
							for (x=0; x<MAX_TILES_ACROSS; x++)
								if (tilewin->tile[x][y])
									filemgr->SaveImage(tilewin->tile[x][y]-1);
						}
					else if (input_grid_mode == EXTENDED_SINGLE)
						filemgr->SaveImage(tilewin->tile[tilewin->tile_selected_x][tilewin->tile_selected_y]-1);

					handled = true;
					break;

				case cmdSaveAll:
					filemgr->SaveImages();

					handled = true;
					break;

				case cmdFillImage:
				case cmdClearImage:
					if (e.command.event == cmdFillImage)
						grClearImage(current_image,color1);
					else
						grClearImage(current_image,color2);

					tilewin->UseTiledImage();
					editwin->Refresh();
					tilewin->Refresh();
					thumbwin->Refresh();

					handled = true;
					break;

				case cmdStoreImage:
					ResetStore();
					grCopyImage(store,current_image);
					storeUsed = true;

					handled = true;
					break;

				case cmdGetImage:
					if (storeUsed)
						{
						current_image->hdr.width = store->hdr.width;
						current_image->hdr.height = store->hdr.height;
						grCopyImage(current_image,store);

						tilewin->MakeTiledImage();

						editwin->Refresh();
						tilewin->Refresh();
						thumbwin->Refresh();
						}

					handled = true;
					break;

				case cmdScrollUpFive:
					grScrollImageVertical(current_image,-4);
				case cmdScrollUp:
					grScrollImageVertical(current_image,-1);

					tilewin->UseTiledImage();
					editwin->Refresh();
					tilewin->Refresh();
					thumbwin->Refresh();

					handled = true;
					break;

				case cmdScrollLeftFive:
					grScrollImageHorizontal(current_image,-4);
				case cmdScrollLeft:
					grScrollImageHorizontal(current_image,-1);

					tilewin->UseTiledImage();
					editwin->Refresh();
					tilewin->Refresh();
					thumbwin->Refresh();

					handled = true;
					break;

				case cmdScrollRightFive:
					grScrollImageHorizontal(current_image,4);
				case cmdScrollRight:
					grScrollImageHorizontal(current_image,1);

					tilewin->UseTiledImage();
					editwin->Refresh();
					tilewin->Refresh();
					thumbwin->Refresh();

					handled = true;
					break;

				case cmdScrollDownFive:
					grScrollImageVertical(current_image,4);
				case cmdScrollDown:
					grScrollImageVertical(current_image,1);

					tilewin->UseTiledImage();
					editwin->Refresh();
					tilewin->Refresh();
					thumbwin->Refresh();

					handled = true;
					break;

				case cmdDecreaseHeightBottom:
				case cmdIncreaseHeightBottom:
				case cmdDecreaseWidthRight:
				case cmdIncreaseWidthRight:
					if (input_grid_mode != SINGLE) break;

					current_image = image[current_image_index];

					memcpy(undo,current_image,grImageSize(0,0,current_image->hdr.width-1,current_image->hdr.height-1));
					undoUsed = true;

					ResetWorking();
					grCopyImage(working,current_image);

					if (e.command.event == cmdDecreaseHeightBottom)
						current_image->hdr.height--;
					if (e.command.event == cmdIncreaseHeightBottom)
						current_image->hdr.height++;
					if (e.command.event == cmdDecreaseWidthRight)
						current_image->hdr.width--;
					if (e.command.event == cmdIncreaseWidthRight)
						current_image->hdr.width++;

					ResizeImageIfNecessary(current_image);

					grCopyImageData(current_image,working);

					editwin->Refresh();
					tilewin->Refresh();
					thumbwin->Refresh();

					handled = true;
					break;

				case cmdDecreaseHeightTop:
				case cmdIncreaseHeightTop:
				case cmdDecreaseWidthLeft:
				case cmdIncreaseWidthLeft:
					if (input_grid_mode != SINGLE) break;

					current_image = image[current_image_index];

					memcpy(undo,current_image,grImageSize(0,0,current_image->hdr.width-1,current_image->hdr.height-1));
					undoUsed = true;

					// scroll image so it seems we have decreased from top left edge
					if (e.command.event == cmdDecreaseHeightTop)
						grScrollImageVertical(current_image,-1);
					if (e.command.event == cmdDecreaseWidthLeft)
						grScrollImageHorizontal(current_image,-1);

					ResetWorking();
					grCopyImage(working,current_image);

					if (e.command.event == cmdDecreaseHeightTop)
						current_image->hdr.height--;
					if (e.command.event == cmdIncreaseHeightTop)
						current_image->hdr.height++;
					if (e.command.event == cmdDecreaseWidthLeft)
						current_image->hdr.width--;
					if (e.command.event == cmdIncreaseWidthLeft)
						current_image->hdr.width++;

					ResizeImageIfNecessary(current_image);

					grCopyImageData(current_image,working);

					// scroll image so it seems we have increased from top left edge
					if (e.command.event == cmdIncreaseHeightTop)
						grScrollImageVertical(current_image,1);
					if (e.command.event == cmdIncreaseWidthLeft)
						grScrollImageHorizontal(current_image,1);

					editwin->Refresh();
					tilewin->Refresh();
					thumbwin->Refresh();

					handled = true;
					break;

				case cmdFlipHorizontal:
					grFlipImageHorizontal(current_image);

					tilewin->UseTiledImage();
					editwin->Refresh();
					tilewin->Refresh();
					thumbwin->Refresh();

					handled = true;
					break;

				case cmdFlipVertical:
					grFlipImageVertical(current_image);

					tilewin->UseTiledImage();
					editwin->Refresh();
					tilewin->Refresh();
					thumbwin->Refresh();

					handled = true;
					break;

				case cmdRotate270:
					grRotateImage(current_image,NINETY);
				case cmdRotate180:
					grRotateImage(current_image,NINETY);
				case cmdRotate90:
					grRotateImage(current_image,NINETY);

					tilewin->UseTiledImage();
					editwin->Refresh();
					tilewin->Refresh();
					thumbwin->Refresh();

					handled = true;
					break;

				case cmdErase:
					input_query_mode = NORMAL_INPUT;
					output_fill_mode = NONE;
					output_draw_mode = ERASE;
					Draw();

					handled = true;
					break;

				case cmdFilledErase:
					input_query_mode = NORMAL_INPUT;
					output_fill_mode = SOLID;
					output_draw_mode = ERASE;
					Draw();

					handled = true;
					break;

				case cmdDraw:
					input_query_mode = NORMAL_INPUT;
					output_fill_mode = NONE;
					output_draw_mode = DRAW;
					Draw();

					handled = true;
					break;

				case cmdFilledDraw:
					input_query_mode = NORMAL_INPUT;
					output_fill_mode = SOLID;
					output_draw_mode = DRAW;
					Draw();

					handled = true;
					break;

				case cmdLine:
					input_query_mode = NORMAL_INPUT;
					output_fill_mode = NONE;
					output_draw_mode = LINE;
					Draw();

					handled = true;
					break;

				case cmdFlatLine:
					input_query_mode = NORMAL_INPUT;
					output_fill_mode = NONE;
					output_draw_mode = FLATLINE;
					Draw();

					handled = true;
					break;

				case cmdRect:
					input_query_mode = NORMAL_INPUT;
					output_fill_mode = NONE;
					output_draw_mode = RECT;
					Draw();

					handled = true;
					break;

				case cmdFilledRect:
					input_query_mode = NORMAL_INPUT;
					output_fill_mode = SOLID;
					output_draw_mode = RECT;
					Draw();

					handled = true;
					break;

				case cmdEllipse:
					input_query_mode = NORMAL_INPUT;
					output_fill_mode = NONE;
					output_draw_mode = ELLIPSE;
					Draw();

					handled = true;
					break;

				case cmdFilledEllipse:
					input_query_mode = NORMAL_INPUT;
					output_fill_mode = SOLID;
					output_draw_mode = ELLIPSE;
					Draw();

					handled = true;
					break;

				case cmdFill:
					output_fill_mode = !output_fill_mode;
					input_query_mode = NORMAL_INPUT;
					Draw();

					handled = true;
					break;

				case cmdUndo:
					if (undoUsed)
						{
						memcpy(working,current_image,grImageSize(0,0,current_image->hdr.width-1,current_image->hdr.height-1));
						grCopyImage(current_image,undo);
						memcpy(undo,working,grImageSize(0,0,working->hdr.width-1,working->hdr.height-1));

						editwin->Refresh();
						thumbwin->Refresh();
						tilewin->Refresh();
						}

					handled = true;
					break;

				case cmdSingle:
					output_tile_mode = SINGLE;
					input_grid_mode = SINGLE;

					editwin->Refresh();
					tilewin->Refresh();
					handled = true;
					break;

				case cmdRepeat:
					if (output_tile_mode == REPEAT)
						output_tile_mode = SINGLE;
					else
						output_tile_mode = REPEAT;

					tilewin->Refresh();
					handled = true;
					break;

				case cmdTile:
					output_tile_mode = SINGLE;
					input_grid_mode = EXTENDED;

					if (!tilewin->any_tiles_selected)
						tilewin->tile[0][0] = current_image_index+1;

					tilewin->MakeTiledImage();

					editwin->Refresh();
					tilewin->Refresh();
					handled = true;
					break;

				case cmdClearTile:
					tilewin->ClearTiledImage();

					tilewin->tile[0][0] = current_image_index+1;
					tilewin->MakeTiledImage();

					editwin->Refresh();
					tilewin->Refresh();
					handled = true;
					break;

				case cmdGotoPalette:
					editwin->Close();
					thumbwin->Close();
					Close();

//					grClearScreen(grBACKGROUND);
//					grBlitScreen();

					basewin->Open();
					fillrngwin->Open();
					palbutwin->Open();

					basewin->Refresh();
					fillrngwin->Refresh();
					palbutwin->Refresh();

//					EVENTMGR->DrawAllHandlers();
//					grBlitScreen();

					screen_mode = GUI_PALETTE;
					handled = true;
					break;
				}
			break;
		}

	// if we handled an event here then clear it HERE!!
	if (handled) EVENTMGR->ClearEvent(e);
	if (screen_mode == GUI_PALETTE) EVENTMGR->ClearAllEvents();
	}

//==========================================================================

PalButtonRegion::PalButtonRegion()
	: OnScreenHandler(max_edit_x2,max_tile_y2,thumb_x1-1,grMaxy,&evhno_PalButtonRegion,0,1)
	{
	if (screen_mode == GUI_PALETTE)	isOnScreen = true;
	else							isOnScreen = false;

	int	width = GUIbitmap[0]->hdr.width,
		height = GUIbitmap[0]->hdr.height;

	// ---------------------------------------------------------------------

	// Disk/System Button creation

	int	x1 = 0,
		x2 = x1 + width,
		x3 = x2 + width,
		x4 = x3 + width,
		x5 = x4 + width,
		y  = 0;

	// first row
	y += grFontHeight();

	// Button accessory creation
	AddAccessory(new PictureButton(x1,y,
					GUIbitmap[GUI_LOAD],GUIbitmap[GUI_LOAD+1],0,cmdLoad));

	AddAccessory(new PictureButton(x2,y,
					GUIbitmap[GUI_SAVE],GUIbitmap[GUI_SAVE+1],0,cmdSave));

	AddAccessory(new PictureButton(x3,y,
					GUIbitmap[GUI_QUIT],GUIbitmap[GUI_QUIT+1],0,cmdExitProgram));

	// Window Selection Buttons

	AddAccessory(new PictureButton(x4,y,
					GUIbitmap[GUI_ICONS],GUIbitmap[GUI_ICONS+1],0,cmdGotoIcons));

//===========================================================================

	// x positions for left buttons and right buttons
	leftend_x = 0;
	left_x = left_x + width;

	middle_x = left_x + width;

	right_x = middle_x + width + gap*2;
	rightend_x = right_x + width;

	// Top Arrows
	red1_y = height + gap;
	green1_y = red1_y + height;
	blue1_y = green1_y + height;

	// Bottom Arrows

	red2_y = gap + blue1_y + height;
	green2_y = red2_y + height;
	blue2_y = green2_y + height;

	// arrow button accessory creation

	//======= for start color1 control arrows
	AddAccessory(new PictureButton(leftend_x,red1_y,GUIbitmap[GUI_LEFT],GUIbitmap[GUI_LEFT+1],0,cmd_r1_lll));
	AddAccessory(new PictureButton(left_x,red1_y,GUIbitmap[GUI_LEFT],GUIbitmap[GUI_LEFT+1],0,cmd_r1_l,cmd_r1_ll));
	AddAccessory(new PictureButton(right_x,red1_y,GUIbitmap[GUI_RIGHT],GUIbitmap[GUI_RIGHT+1],0,cmd_r1_r,cmd_r1_rr));
	AddAccessory(new PictureButton(rightend_x,red1_y,GUIbitmap[GUI_RIGHT],GUIbitmap[GUI_RIGHT+1],0,cmd_r1_rrr));

	AddAccessory(new PictureButton(leftend_x,green1_y,GUIbitmap[GUI_LEFT],GUIbitmap[GUI_LEFT+1],0,cmd_g1_lll));
	AddAccessory(new PictureButton(left_x,green1_y,GUIbitmap[GUI_LEFT],GUIbitmap[GUI_LEFT+1],0,cmd_g1_l,cmd_g1_ll));
	AddAccessory(new PictureButton(right_x,green1_y,GUIbitmap[GUI_RIGHT],GUIbitmap[GUI_RIGHT+1],0,cmd_g1_r,cmd_g1_rr));
	AddAccessory(new PictureButton(rightend_x,green1_y,GUIbitmap[GUI_RIGHT],GUIbitmap[GUI_RIGHT+1],0,cmd_g1_rrr));

	AddAccessory(new PictureButton(leftend_x,blue1_y,GUIbitmap[GUI_LEFT],GUIbitmap[GUI_LEFT+1],0,cmd_b1_lll));
	AddAccessory(new PictureButton(left_x,blue1_y,GUIbitmap[GUI_LEFT],GUIbitmap[GUI_LEFT+1],0,cmd_b1_l,cmd_b1_ll));
	AddAccessory(new PictureButton(right_x,blue1_y,GUIbitmap[GUI_RIGHT],GUIbitmap[GUI_RIGHT+1],0,cmd_b1_r,cmd_b1_rr));
	AddAccessory(new PictureButton(rightend_x,blue1_y,GUIbitmap[GUI_RIGHT],GUIbitmap[GUI_RIGHT+1],0,cmd_b1_rrr));

	//======= for end color2 control arrows
	AddAccessory(new PictureButton(leftend_x,red2_y,GUIbitmap[GUI_LEFT],GUIbitmap[GUI_LEFT+1],0,cmd_r2_lll));
	AddAccessory(new PictureButton(left_x,red2_y,GUIbitmap[GUI_LEFT],GUIbitmap[GUI_LEFT+1],0,cmd_r2_l,cmd_r2_ll));
	AddAccessory(new PictureButton(right_x,red2_y,GUIbitmap[GUI_RIGHT],GUIbitmap[GUI_RIGHT+1],0,cmd_r2_r,cmd_r2_rr));
	AddAccessory(new PictureButton(rightend_x,red2_y,GUIbitmap[GUI_RIGHT],GUIbitmap[GUI_RIGHT+1],0,cmd_r2_rrr));

	AddAccessory(new PictureButton(leftend_x,green2_y,GUIbitmap[GUI_LEFT],GUIbitmap[GUI_LEFT+1],0,cmd_g2_lll));
	AddAccessory(new PictureButton(left_x,green2_y,GUIbitmap[GUI_LEFT],GUIbitmap[GUI_LEFT+1],0,cmd_g2_l,cmd_g2_ll));
	AddAccessory(new PictureButton(right_x,green2_y,GUIbitmap[GUI_RIGHT],GUIbitmap[GUI_RIGHT+1],0,cmd_g2_r,cmd_g2_rr));
	AddAccessory(new PictureButton(rightend_x,green2_y,GUIbitmap[GUI_RIGHT],GUIbitmap[GUI_RIGHT+1],0,cmd_g2_rrr));

	AddAccessory(new PictureButton(leftend_x,blue2_y,GUIbitmap[GUI_LEFT],GUIbitmap[GUI_LEFT+1],0,cmd_b2_lll));
	AddAccessory(new PictureButton(left_x,blue2_y,GUIbitmap[GUI_LEFT],GUIbitmap[GUI_LEFT+1],0,cmd_b2_l,cmd_b2_ll));
	AddAccessory(new PictureButton(right_x,blue2_y,GUIbitmap[GUI_RIGHT],GUIbitmap[GUI_RIGHT+1],0,cmd_b2_r,cmd_b2_rr));
	AddAccessory(new PictureButton(rightend_x,blue2_y,GUIbitmap[GUI_RIGHT],GUIbitmap[GUI_RIGHT+1],0,cmd_b2_rrr));
	}

PalButtonRegion::~PalButtonRegion()
	{
	DelAllAccessories();
	}

void PalButtonRegion::Draw()
	{
	grDrawFilledRect(r.left,r.top,r.right,r.bottom,grBACKGROUND);

	// blank out old numbers
//	grDrawFilledRect(r.left+middle_x,r.top+red1_y, r.left+right_x-1,r.top+blue2_y+gap,grBACKGROUND);

	// get the start and end red, green and blue values
	grGetPaletteEntry(color1,&r1,&g1,&b1);
	grGetPaletteEntry(color2,&r2,&g2,&b2);

	// draw in the new numbers
	grDrawString(r.left+middle_x+2,r.top+red1_y+5,itoa(r1,NULL,10));
	grDrawString(r.left+middle_x+2,r.top+green1_y+5,itoa(g1,NULL,10));
	grDrawString(r.left+middle_x+2,r.top+blue1_y+5,itoa(b1,NULL,10));
	grDrawString(r.left+middle_x+2,r.top+red2_y+5,itoa(r2,NULL,10));
	grDrawString(r.left+middle_x+2,r.top+green2_y+5,itoa(g2,NULL,10));
	grDrawString(r.left+middle_x+2,r.top+blue2_y+5,itoa(b2,NULL,10));

	DrawAllAccessories();
DBG(470,"Finished palbutwin->Draw");
	}

void PalButtonRegion::HandleEvent(Event& e)
	{
	OnScreenHandler::HandleEvent(e);

	bool	handled = false;

	switch (e.what)
		{
		case ev_command:
			handled = HandleArrows(e);

			if (!handled) switch (e.command.event)
				{
				// other commands
				case cmdLoad:

					filemgr->LoadPalette();

					Refresh();

					handled = true;
					break;

				case cmdSave:
					filemgr->SavePalette();

					handled = true;
					break;

				case cmdFill:
					fillrngwin->FillRangeBar();

					handled = true;
					break;

				case cmdGotoIcons:
					// if there are no icons available then break
					if (!icons_available) break;

					basewin->Close();
					fillrngwin->Close();
					Close();

//					grClearScreen(grBACKGROUND);
//					grBlitScreen();

					editwin->Open();
					thumbwin->Open();
					bmpbutwin->Open();

					editwin->Refresh();
					thumbwin->Refresh();
					bmpbutwin->Refresh();

//					EVENTMGR->DrawAllHandlers();
//					grBlitScreen();

					screen_mode = GUI_ICONS;
					handled = true;
					break;
				}
			break;
		}

	// if we handled an event here then clear it HERE!!
	if (handled) EVENTMGR->ClearEvent(e);
	if (screen_mode == GUI_ICONS) EVENTMGR->ClearAllEvents();
	}

void PalButtonRegion::ModifyColour(int index, int entry, int movement)
	{
	uchar	red,green,blue;
	grGetPaletteEntry(index,&red,&green,&blue);
	int	r = red, g = green, b = blue;

	switch (entry)
		{
		case 1: r += movement; break;
		case 2: g += movement; break;
		case 3: b += movement; break;
		}

	if (r<0) r = 0; if (g<0) g = 0; if (b<0) b = 0;
	if (r>63) r = 63; if (g>63) g = 63; if (b>63) b = 63;

	red = r; green = g; blue = b;

	grSetPaletteEntry(index,red,green,blue);
	grGetPalette(palette,0,255);
	Refresh();
	}

bool PalButtonRegion::HandleArrows(Event& e)
	{
	bool	handled = false;

	switch (e.command.event)
		{
		// NORMAL arrow commands

		case cmd_r1_l:
			ModifyColour(color1,1,-1);
			handled = true;
			break;
		case cmd_g1_l:
			ModifyColour(color1,2,-1);
			handled = true;
			break;
		case cmd_b1_l:
			ModifyColour(color1,3,-1);
			handled = true;
			break;

		case cmd_r2_l:
			ModifyColour(color2,1,-1);
			handled = true;
			break;
		case cmd_g2_l:
			ModifyColour(color2,2,-1);
			handled = true;
			break;
		case cmd_b2_l:
			ModifyColour(color2,3,-1);
			handled = true;
			break;

		case cmd_r1_r:
			ModifyColour(color1,1,1);
			handled = true;
			break;
		case cmd_g1_r:
			ModifyColour(color1,2,1);
			handled = true;
			break;
		case cmd_b1_r:
			ModifyColour(color1,3,1);
			handled = true;
			break;

		case cmd_r2_r:
			ModifyColour(color2,1,1);
			handled = true;
			break;
		case cmd_g2_r:
			ModifyColour(color2,2,1);
			handled = true;
			break;
		case cmd_b2_r:
			ModifyColour(color2,3,1);
			handled = true;
			break;

		// FAST arrow commands

		case cmd_r1_ll:
			ModifyColour(color1,1,-5);
			handled = true;
			break;
		case cmd_g1_ll:
			ModifyColour(color1,2,-5);
			handled = true;
			break;
		case cmd_b1_ll:
			ModifyColour(color1,3,-5);
			handled = true;
			break;

		case cmd_r2_ll:
			ModifyColour(color2,1,-5);
			handled = true;
			break;
		case cmd_g2_ll:
			ModifyColour(color2,2,-5);
			handled = true;
			break;
		case cmd_b2_ll:
			ModifyColour(color2,3,-5);
			handled = true;
			break;

		case cmd_r1_rr:
			ModifyColour(color1,1,5);
			handled = true;
			break;
		case cmd_g1_rr:
			ModifyColour(color1,2,5);
			handled = true;
			break;
		case cmd_b1_rr:
			ModifyColour(color1,3,5);
			handled = true;
			break;

		case cmd_r2_rr:
			ModifyColour(color2,1,5);
			handled = true;
			break;
		case cmd_g2_rr:
			ModifyColour(color2,2,5);
			handled = true;
			break;
		case cmd_b2_rr:
			ModifyColour(color2,3,5);
			handled = true;
			break;

		// END arrow commands

		case cmd_r1_lll:
			ModifyColour(color1,1,-1000);
			handled = true;
			break;
		case cmd_g1_lll:
			ModifyColour(color1,2,-1000);
			handled = true;
			break;
		case cmd_b1_lll:
			ModifyColour(color1,3,-1000);
			handled = true;
			break;

		case cmd_r2_lll:
			ModifyColour(color2,1,-1000);
			handled = true;
			break;
		case cmd_g2_lll:
			ModifyColour(color2,2,-1000);
			handled = true;
			break;
		case cmd_b2_lll:
			ModifyColour(color2,3,-1000);
			handled = true;
			break;

		case cmd_r1_rrr:
			ModifyColour(color1,1,1000);
			handled = true;
			break;
		case cmd_g1_rrr:
			ModifyColour(color1,2,1000);
			handled = true;
			break;
		case cmd_b1_rrr:
			ModifyColour(color1,3,1000);
			handled = true;
			break;

		case cmd_r2_rrr:
			ModifyColour(color2,1,1000);
			handled = true;
			break;
		case cmd_g2_rrr:
			ModifyColour(color2,2,1000);
			handled = true;
			break;
		case cmd_b2_rrr:
			ModifyColour(color2,3,1000);
			handled = true;
			break;
		}

	return handled;
	}
