//	-------------------------------------------------------------------------
//
//	EDITWIN.HPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Andrew Carvel Evans
//
//	DESCRIPTION:	This is the Editting Window
//
//	-------------------------------------------------------------------------

#ifndef	__editwin_hpp
#define	__editwin_hpp

#include "onscreen.hpp"
#include "grid.hpp"

#include "tooldefn.hpp"

class EditRegion : public OnScreenHandler
	{
	public:
		Grid*	edit_region;

				EditRegion();
				~EditRegion();

		// grid/image manipulation
		void	HandleDrawing(Event& e);

		void	AdjustCoords(int* x,int* y);
		void	PutPoint(grCell cell,uchar color);
		void	PutLine(uchar color);
		void	PutRect(uchar color);
		void	PutEllipse(uchar color);

		// functions for drawing
		void	ResizeEditRegion();
		void	DrawRegion(int x1,int y1,int x2,int y2);
		void	RefreshRegion(int x1,int y1,int x2,int y2);
		void	DrawMouseXYPos(grPoint m);
		void	DrawGridDetails();

		// standard
		void	Draw();
		void	HandleEvent(Event& e);
	};

extern	int				evhno_EditRegion;
extern	EditRegion*		editwin;

#endif
