//	-------------------------------------------------------------------------
//
//	FILEMGNT.HPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Andrew Carvel Evans
//
//	DESCRIPTION:	This is the File Manager for Tool
//
//	-------------------------------------------------------------------------

#ifndef	__filemgnt_hpp
#define	__filemgnt_hpp

#include "backgrnd.hpp"
#include "strings.hpp"

#include "tooldefn.hpp"

class FileManager : public BackgroundTask
	{
	public:
					FileManager();
					~FileManager();

		void		HandleEvent(Event& e);
		void		Draw();

		// startup functions
		void		SetupImages();
		void		SetupPalette();

		// image disk functions
		void		LoadDEFFile();
		void		FreeDEFFile();

		void		LoadPCXFiles();
		void		FreePCXFiles();

		bool		ImageOnDiskIsOK(PCXFile* pf);

		void		LoadImage(int i);
		void		SaveImage(int i);
		void		FreeImage(int i);

		void		LoadImages();
		void		SaveImages();
		void		FreeImages();

		// palette disk functions
		void		LoadPalette();
		void		SavePalette();
	};

extern	int				evhno_FileManager;
extern	FileManager*	filemgr;

#endif
