//	-------------------------------------------------------------------------
//
//	TILEWIN.HPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Andrew Carvel Evans
//
//	DESCRIPTION:	This is the Tile Window
//
//	-------------------------------------------------------------------------

#ifndef	__tilewin_hpp
#define __tilewin_hpp

#include "onscreen.hpp"
#include "grid.hpp"

#include "tooldefn.hpp"

class TileRegion : public OnScreenHandler
	{
	public:
		// a grid used to select tile positions
		Grid*	tile_grid;

		// an array to store which images+1 are in what positions on tile
		int		tile[MAX_TILES_ACROSS][MAX_TILES_DOWN];

		bool	any_tiles_selected;
		int		tile_selected_x,
				tile_selected_y;

		int		tiles_across,
				tiles_down;
		int		tile_width,
				tile_height;

				TileRegion();
				~TileRegion();

		void	ClearTiledImage();
		void	MakeTiledImage();
		void	UseTiledImage();

		void	DrawTileSelect();
		void	Draw();
		void	Refresh();
		void	HandleEvent(Event& e);
	};

extern	int				evhno_TileRegion;
extern	TileRegion*		tilewin;

#endif
