//	-------------------------------------------------------------------------
//
//	TOOL.HPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Andrew C. Evans
//
//	DESCRIPTION:	This file defines the main program (derived from Program)
//
//	-------------------------------------------------------------------------

#ifndef __tool_hpp
#define __tool_hpp

#include "program.hpp"
#include "strings.hpp"
#include "resource.hpp"
#include "graphics.hpp"

//	-------------------------------------------------------------------------
//
//	CLASS:		TOOL
//	DESC:		The MAIN object which is the "program". See PROGRAM.?PP
//
//	-------------------------------------------------------------------------

class TOOL: public Program
	{
	private:
	public:
		TOOL(char* bmpname,char* palname, char* Init_String, int options);
		virtual ~TOOL();

		void Init_GUI();
		void Exit_GUI();

		void Init_Variables();
		void Exit_Variables();

		void Init_Handlers();
		void Exit_Handlers();

		void MainLoop();
	};

//	-------------------------------------------------------------------------
//
//	FUNC:		main()
//	DESC:		This is the function called initially.
//				At the moment it:
//					(1) creates our program
//					(2) executes Program::Execute()
//					(5) deletes our program & exits
//
//	-------------------------------------------------------------------------
void main(int argc, char* argv[]);

#endif